/* Autogenerated: '../../../../../fiat-crypto/src/ExtractionOCaml/fiat_crypto'
 * word-by-word-montgomery p65376 64 '65*2^376-1' */
/* curve description: p65376 */
/* machine_wordsize = 64 (from "64") */
/* requested operations: (all) */
/* m =
 * 0x40ffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffffff
 * (from "65*2^376-1") */
/*                                                                    */
/* NOTE: In addition to the bounds specified above each function, all */
/*   functions synthesized for this Montgomery arithmetic require the */
/*   input to be strictly less than the prime modulus (m), and also   */
/*   require the input to be in the unique saturated representation.  */
/*   All functions also ensure that these two properties are true of  */
/*   return values.                                                   */
/*  */
/* Computed values: */
/*   eval z = z[0] + (z[1] << 64) + (z[2] << 128) + (z[3] << 192) + (z[4] << 256) + (z[5] << 0x140)
 */
/*   bytes_eval z = z[0] + (z[1] << 8) + (z[2] << 16) + (z[3] << 24) + (z[4] << 32) + (z[5] << 40) +
 * (z[6] << 48) + (z[7] << 56) + (z[8] << 64) + (z[9] << 72) + (z[10] << 80) + (z[11] << 88) +
 * (z[12] << 96) + (z[13] << 104) + (z[14] << 112) + (z[15] << 120) + (z[16] << 128) + (z[17] <<
 * 136) + (z[18] << 144) + (z[19] << 152) + (z[20] << 160) + (z[21] << 168) + (z[22] << 176) +
 * (z[23] << 184) + (z[24] << 192) + (z[25] << 200) + (z[26] << 208) + (z[27] << 216) + (z[28] <<
 * 224) + (z[29] << 232) + (z[30] << 240) + (z[31] << 248) + (z[32] << 256) + (z[33] << 0x108) +
 * (z[34] << 0x110) + (z[35] << 0x118) + (z[36] << 0x120) + (z[37] << 0x128) + (z[38] << 0x130) +
 * (z[39] << 0x138) + (z[40] << 0x140) + (z[41] << 0x148) + (z[42] << 0x150) + (z[43] << 0x158) +
 * (z[44] << 0x160) + (z[45] << 0x168) + (z[46] << 0x170) + (z[47] << 0x178) */
/*   twos_complement_eval z = let x1 := z[0] + (z[1] << 64) + (z[2] << 128) + (z[3] << 192) + (z[4]
 * << 256) + (z[5] << 0x140) in */
/*                            if x1 & (2^384-1) < 2^383 then x1 & (2^384-1) else (x1 & (2^384-1)) -
 * 2^384 */

#include <stdint.h>
typedef unsigned char fiat_p65376_uint1;
typedef signed char fiat_p65376_int1;
#if defined(__GNUC__) || defined(__clang__)
#define FIAT_P65376_FIAT_EXTENSION __extension__
#define FIAT_P65376_FIAT_INLINE __inline__
#else
#define FIAT_P65376_FIAT_EXTENSION
#define FIAT_P65376_FIAT_INLINE
#endif

FIAT_P65376_FIAT_EXTENSION typedef signed __int128 fiat_p65376_int128;
FIAT_P65376_FIAT_EXTENSION typedef unsigned __int128 fiat_p65376_uint128;

/* The type fiat_p65376_montgomery_domain_field_element is a field element in the Montgomery domain.
 */
/* Bounds: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] */
typedef uint64_t fiat_p65376_montgomery_domain_field_element[6];

/* The type fiat_p65376_non_montgomery_domain_field_element is a field element NOT in the Montgomery
 * domain. */
/* Bounds: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] */
typedef uint64_t fiat_p65376_non_montgomery_domain_field_element[6];

#if (-1 & 3) != 3
#error "This code only works on a two's complement system"
#endif

/*
 * The function fiat_p65376_addcarryx_u64 is an addition with carry.
 *
 * Postconditions:
 *   out1 = (arg1 + arg2 + arg3) mod 2^64
 *   out2 = ⌊(arg1 + arg2 + arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
void
fiat_p65376_addcarryx_u64(uint64_t *out1,
                          fiat_p65376_uint1 *out2,
                          fiat_p65376_uint1 arg1,
                          uint64_t arg2,
                          uint64_t arg3)
{
    fiat_p65376_uint128 x1;
    uint64_t x2;
    fiat_p65376_uint1 x3;
    x1 = ((arg1 + (fiat_p65376_uint128)arg2) + arg3);
    x2 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
    x3 = (fiat_p65376_uint1)(x1 >> 64);
    *out1 = x2;
    *out2 = x3;
}

/*
 * The function fiat_p65376_subborrowx_u64 is a subtraction with borrow.
 *
 * Postconditions:
 *   out1 = (-arg1 + arg2 + -arg3) mod 2^64
 *   out2 = -⌊(-arg1 + arg2 + -arg3) / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0x1]
 */
void
fiat_p65376_subborrowx_u64(uint64_t *out1,
                           fiat_p65376_uint1 *out2,
                           fiat_p65376_uint1 arg1,
                           uint64_t arg2,
                           uint64_t arg3)
{
    fiat_p65376_int128 x1;
    fiat_p65376_int1 x2;
    uint64_t x3;
    x1 = ((arg2 - (fiat_p65376_int128)arg1) - arg3);
    x2 = (fiat_p65376_int1)(x1 >> 64);
    x3 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
    *out1 = x3;
    *out2 = (fiat_p65376_uint1)(0x0 - x2);
}

/*
 * The function fiat_p65376_mulx_u64 is a multiplication, returning the full double-width result.
 *
 * Postconditions:
 *   out1 = (arg1 * arg2) mod 2^64
 *   out2 = ⌊arg1 * arg2 / 2^64⌋
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 *   out2: [0x0 ~> 0xffffffffffffffff]
 */
void
fiat_p65376_mulx_u64(uint64_t *out1, uint64_t *out2, uint64_t arg1, uint64_t arg2)
{
    fiat_p65376_uint128 x1;
    uint64_t x2;
    uint64_t x3;
    x1 = ((fiat_p65376_uint128)arg1 * arg2);
    x2 = (uint64_t)(x1 & UINT64_C(0xffffffffffffffff));
    x3 = (uint64_t)(x1 >> 64);
    *out1 = x2;
    *out2 = x3;
}

/*
 * The function fiat_p65376_cmovznz_u64 is a single-word conditional move.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [0x0 ~> 0xffffffffffffffff]
 *   arg3: [0x0 ~> 0xffffffffffffffff]
 * Output Bounds:
 *   out1: [0x0 ~> 0xffffffffffffffff]
 */
void
fiat_p65376_cmovznz_u64(uint64_t *out1, fiat_p65376_uint1 arg1, uint64_t arg2, uint64_t arg3)
{
    fiat_p65376_uint1 x1;
    uint64_t x2;
    uint64_t x3;
    x1 = (!(!arg1));
    x2 = ((fiat_p65376_int1)(0x0 - x1) & UINT64_C(0xffffffffffffffff));
    x3 = ((x2 & arg3) | ((~x2) & arg2));
    *out1 = x3;
}

/*
 * The function fiat_p65376_mul multiplies two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg2))
 * mod m 0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_mul(fiat_p65376_montgomery_domain_field_element out1,
                const fiat_p65376_montgomery_domain_field_element arg1,
                const fiat_p65376_montgomery_domain_field_element arg2)
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint64_t x7;
    uint64_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    uint64_t x15;
    uint64_t x16;
    uint64_t x17;
    uint64_t x18;
    uint64_t x19;
    fiat_p65376_uint1 x20;
    uint64_t x21;
    fiat_p65376_uint1 x22;
    uint64_t x23;
    fiat_p65376_uint1 x24;
    uint64_t x25;
    fiat_p65376_uint1 x26;
    uint64_t x27;
    fiat_p65376_uint1 x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint64_t x32;
    uint64_t x33;
    uint64_t x34;
    uint64_t x35;
    uint64_t x36;
    uint64_t x37;
    uint64_t x38;
    uint64_t x39;
    uint64_t x40;
    uint64_t x41;
    uint64_t x42;
    fiat_p65376_uint1 x43;
    uint64_t x44;
    fiat_p65376_uint1 x45;
    uint64_t x46;
    fiat_p65376_uint1 x47;
    uint64_t x48;
    fiat_p65376_uint1 x49;
    uint64_t x50;
    fiat_p65376_uint1 x51;
    uint64_t x52;
    uint64_t x53;
    fiat_p65376_uint1 x54;
    uint64_t x55;
    fiat_p65376_uint1 x56;
    uint64_t x57;
    fiat_p65376_uint1 x58;
    uint64_t x59;
    fiat_p65376_uint1 x60;
    uint64_t x61;
    fiat_p65376_uint1 x62;
    uint64_t x63;
    fiat_p65376_uint1 x64;
    uint64_t x65;
    fiat_p65376_uint1 x66;
    uint64_t x67;
    uint64_t x68;
    uint64_t x69;
    uint64_t x70;
    uint64_t x71;
    uint64_t x72;
    uint64_t x73;
    uint64_t x74;
    uint64_t x75;
    uint64_t x76;
    uint64_t x77;
    uint64_t x78;
    uint64_t x79;
    fiat_p65376_uint1 x80;
    uint64_t x81;
    fiat_p65376_uint1 x82;
    uint64_t x83;
    fiat_p65376_uint1 x84;
    uint64_t x85;
    fiat_p65376_uint1 x86;
    uint64_t x87;
    fiat_p65376_uint1 x88;
    uint64_t x89;
    uint64_t x90;
    fiat_p65376_uint1 x91;
    uint64_t x92;
    fiat_p65376_uint1 x93;
    uint64_t x94;
    fiat_p65376_uint1 x95;
    uint64_t x96;
    fiat_p65376_uint1 x97;
    uint64_t x98;
    fiat_p65376_uint1 x99;
    uint64_t x100;
    fiat_p65376_uint1 x101;
    uint64_t x102;
    fiat_p65376_uint1 x103;
    uint64_t x104;
    uint64_t x105;
    uint64_t x106;
    uint64_t x107;
    uint64_t x108;
    uint64_t x109;
    uint64_t x110;
    uint64_t x111;
    uint64_t x112;
    uint64_t x113;
    uint64_t x114;
    uint64_t x115;
    uint64_t x116;
    fiat_p65376_uint1 x117;
    uint64_t x118;
    fiat_p65376_uint1 x119;
    uint64_t x120;
    fiat_p65376_uint1 x121;
    uint64_t x122;
    fiat_p65376_uint1 x123;
    uint64_t x124;
    fiat_p65376_uint1 x125;
    uint64_t x126;
    uint64_t x127;
    fiat_p65376_uint1 x128;
    uint64_t x129;
    fiat_p65376_uint1 x130;
    uint64_t x131;
    fiat_p65376_uint1 x132;
    uint64_t x133;
    fiat_p65376_uint1 x134;
    uint64_t x135;
    fiat_p65376_uint1 x136;
    uint64_t x137;
    fiat_p65376_uint1 x138;
    uint64_t x139;
    fiat_p65376_uint1 x140;
    uint64_t x141;
    uint64_t x142;
    uint64_t x143;
    uint64_t x144;
    uint64_t x145;
    uint64_t x146;
    uint64_t x147;
    uint64_t x148;
    uint64_t x149;
    uint64_t x150;
    uint64_t x151;
    uint64_t x152;
    uint64_t x153;
    uint64_t x154;
    fiat_p65376_uint1 x155;
    uint64_t x156;
    fiat_p65376_uint1 x157;
    uint64_t x158;
    fiat_p65376_uint1 x159;
    uint64_t x160;
    fiat_p65376_uint1 x161;
    uint64_t x162;
    fiat_p65376_uint1 x163;
    uint64_t x164;
    uint64_t x165;
    fiat_p65376_uint1 x166;
    uint64_t x167;
    fiat_p65376_uint1 x168;
    uint64_t x169;
    fiat_p65376_uint1 x170;
    uint64_t x171;
    fiat_p65376_uint1 x172;
    uint64_t x173;
    fiat_p65376_uint1 x174;
    uint64_t x175;
    fiat_p65376_uint1 x176;
    uint64_t x177;
    fiat_p65376_uint1 x178;
    uint64_t x179;
    uint64_t x180;
    uint64_t x181;
    uint64_t x182;
    uint64_t x183;
    uint64_t x184;
    uint64_t x185;
    uint64_t x186;
    uint64_t x187;
    uint64_t x188;
    uint64_t x189;
    uint64_t x190;
    uint64_t x191;
    fiat_p65376_uint1 x192;
    uint64_t x193;
    fiat_p65376_uint1 x194;
    uint64_t x195;
    fiat_p65376_uint1 x196;
    uint64_t x197;
    fiat_p65376_uint1 x198;
    uint64_t x199;
    fiat_p65376_uint1 x200;
    uint64_t x201;
    uint64_t x202;
    fiat_p65376_uint1 x203;
    uint64_t x204;
    fiat_p65376_uint1 x205;
    uint64_t x206;
    fiat_p65376_uint1 x207;
    uint64_t x208;
    fiat_p65376_uint1 x209;
    uint64_t x210;
    fiat_p65376_uint1 x211;
    uint64_t x212;
    fiat_p65376_uint1 x213;
    uint64_t x214;
    fiat_p65376_uint1 x215;
    uint64_t x216;
    uint64_t x217;
    uint64_t x218;
    uint64_t x219;
    uint64_t x220;
    uint64_t x221;
    uint64_t x222;
    uint64_t x223;
    uint64_t x224;
    uint64_t x225;
    uint64_t x226;
    uint64_t x227;
    uint64_t x228;
    uint64_t x229;
    fiat_p65376_uint1 x230;
    uint64_t x231;
    fiat_p65376_uint1 x232;
    uint64_t x233;
    fiat_p65376_uint1 x234;
    uint64_t x235;
    fiat_p65376_uint1 x236;
    uint64_t x237;
    fiat_p65376_uint1 x238;
    uint64_t x239;
    uint64_t x240;
    fiat_p65376_uint1 x241;
    uint64_t x242;
    fiat_p65376_uint1 x243;
    uint64_t x244;
    fiat_p65376_uint1 x245;
    uint64_t x246;
    fiat_p65376_uint1 x247;
    uint64_t x248;
    fiat_p65376_uint1 x249;
    uint64_t x250;
    fiat_p65376_uint1 x251;
    uint64_t x252;
    fiat_p65376_uint1 x253;
    uint64_t x254;
    uint64_t x255;
    uint64_t x256;
    uint64_t x257;
    uint64_t x258;
    uint64_t x259;
    uint64_t x260;
    uint64_t x261;
    uint64_t x262;
    uint64_t x263;
    uint64_t x264;
    uint64_t x265;
    uint64_t x266;
    fiat_p65376_uint1 x267;
    uint64_t x268;
    fiat_p65376_uint1 x269;
    uint64_t x270;
    fiat_p65376_uint1 x271;
    uint64_t x272;
    fiat_p65376_uint1 x273;
    uint64_t x274;
    fiat_p65376_uint1 x275;
    uint64_t x276;
    uint64_t x277;
    fiat_p65376_uint1 x278;
    uint64_t x279;
    fiat_p65376_uint1 x280;
    uint64_t x281;
    fiat_p65376_uint1 x282;
    uint64_t x283;
    fiat_p65376_uint1 x284;
    uint64_t x285;
    fiat_p65376_uint1 x286;
    uint64_t x287;
    fiat_p65376_uint1 x288;
    uint64_t x289;
    fiat_p65376_uint1 x290;
    uint64_t x291;
    uint64_t x292;
    uint64_t x293;
    uint64_t x294;
    uint64_t x295;
    uint64_t x296;
    uint64_t x297;
    uint64_t x298;
    uint64_t x299;
    uint64_t x300;
    uint64_t x301;
    uint64_t x302;
    uint64_t x303;
    uint64_t x304;
    fiat_p65376_uint1 x305;
    uint64_t x306;
    fiat_p65376_uint1 x307;
    uint64_t x308;
    fiat_p65376_uint1 x309;
    uint64_t x310;
    fiat_p65376_uint1 x311;
    uint64_t x312;
    fiat_p65376_uint1 x313;
    uint64_t x314;
    uint64_t x315;
    fiat_p65376_uint1 x316;
    uint64_t x317;
    fiat_p65376_uint1 x318;
    uint64_t x319;
    fiat_p65376_uint1 x320;
    uint64_t x321;
    fiat_p65376_uint1 x322;
    uint64_t x323;
    fiat_p65376_uint1 x324;
    uint64_t x325;
    fiat_p65376_uint1 x326;
    uint64_t x327;
    fiat_p65376_uint1 x328;
    uint64_t x329;
    uint64_t x330;
    uint64_t x331;
    uint64_t x332;
    uint64_t x333;
    uint64_t x334;
    uint64_t x335;
    uint64_t x336;
    uint64_t x337;
    uint64_t x338;
    uint64_t x339;
    uint64_t x340;
    uint64_t x341;
    fiat_p65376_uint1 x342;
    uint64_t x343;
    fiat_p65376_uint1 x344;
    uint64_t x345;
    fiat_p65376_uint1 x346;
    uint64_t x347;
    fiat_p65376_uint1 x348;
    uint64_t x349;
    fiat_p65376_uint1 x350;
    uint64_t x351;
    uint64_t x352;
    fiat_p65376_uint1 x353;
    uint64_t x354;
    fiat_p65376_uint1 x355;
    uint64_t x356;
    fiat_p65376_uint1 x357;
    uint64_t x358;
    fiat_p65376_uint1 x359;
    uint64_t x360;
    fiat_p65376_uint1 x361;
    uint64_t x362;
    fiat_p65376_uint1 x363;
    uint64_t x364;
    fiat_p65376_uint1 x365;
    uint64_t x366;
    uint64_t x367;
    uint64_t x368;
    uint64_t x369;
    uint64_t x370;
    uint64_t x371;
    uint64_t x372;
    uint64_t x373;
    uint64_t x374;
    uint64_t x375;
    uint64_t x376;
    uint64_t x377;
    uint64_t x378;
    uint64_t x379;
    fiat_p65376_uint1 x380;
    uint64_t x381;
    fiat_p65376_uint1 x382;
    uint64_t x383;
    fiat_p65376_uint1 x384;
    uint64_t x385;
    fiat_p65376_uint1 x386;
    uint64_t x387;
    fiat_p65376_uint1 x388;
    uint64_t x389;
    uint64_t x390;
    fiat_p65376_uint1 x391;
    uint64_t x392;
    fiat_p65376_uint1 x393;
    uint64_t x394;
    fiat_p65376_uint1 x395;
    uint64_t x396;
    fiat_p65376_uint1 x397;
    uint64_t x398;
    fiat_p65376_uint1 x399;
    uint64_t x400;
    fiat_p65376_uint1 x401;
    uint64_t x402;
    fiat_p65376_uint1 x403;
    uint64_t x404;
    uint64_t x405;
    uint64_t x406;
    uint64_t x407;
    uint64_t x408;
    uint64_t x409;
    uint64_t x410;
    uint64_t x411;
    uint64_t x412;
    uint64_t x413;
    uint64_t x414;
    uint64_t x415;
    uint64_t x416;
    fiat_p65376_uint1 x417;
    uint64_t x418;
    fiat_p65376_uint1 x419;
    uint64_t x420;
    fiat_p65376_uint1 x421;
    uint64_t x422;
    fiat_p65376_uint1 x423;
    uint64_t x424;
    fiat_p65376_uint1 x425;
    uint64_t x426;
    uint64_t x427;
    fiat_p65376_uint1 x428;
    uint64_t x429;
    fiat_p65376_uint1 x430;
    uint64_t x431;
    fiat_p65376_uint1 x432;
    uint64_t x433;
    fiat_p65376_uint1 x434;
    uint64_t x435;
    fiat_p65376_uint1 x436;
    uint64_t x437;
    fiat_p65376_uint1 x438;
    uint64_t x439;
    fiat_p65376_uint1 x440;
    uint64_t x441;
    uint64_t x442;
    fiat_p65376_uint1 x443;
    uint64_t x444;
    fiat_p65376_uint1 x445;
    uint64_t x446;
    fiat_p65376_uint1 x447;
    uint64_t x448;
    fiat_p65376_uint1 x449;
    uint64_t x450;
    fiat_p65376_uint1 x451;
    uint64_t x452;
    fiat_p65376_uint1 x453;
    uint64_t x454;
    fiat_p65376_uint1 x455;
    uint64_t x456;
    uint64_t x457;
    uint64_t x458;
    uint64_t x459;
    uint64_t x460;
    uint64_t x461;
    x1 = (arg1[1]);
    x2 = (arg1[2]);
    x3 = (arg1[3]);
    x4 = (arg1[4]);
    x5 = (arg1[5]);
    x6 = (arg1[0]);
    fiat_p65376_mulx_u64(&x7, &x8, x6, (arg2[5]));
    fiat_p65376_mulx_u64(&x9, &x10, x6, (arg2[4]));
    fiat_p65376_mulx_u64(&x11, &x12, x6, (arg2[3]));
    fiat_p65376_mulx_u64(&x13, &x14, x6, (arg2[2]));
    fiat_p65376_mulx_u64(&x15, &x16, x6, (arg2[1]));
    fiat_p65376_mulx_u64(&x17, &x18, x6, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x19, &x20, 0x0, x18, x15);
    fiat_p65376_addcarryx_u64(&x21, &x22, x20, x16, x13);
    fiat_p65376_addcarryx_u64(&x23, &x24, x22, x14, x11);
    fiat_p65376_addcarryx_u64(&x25, &x26, x24, x12, x9);
    fiat_p65376_addcarryx_u64(&x27, &x28, x26, x10, x7);
    x29 = (x28 + x8);
    fiat_p65376_mulx_u64(&x30, &x31, x17, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x32, &x33, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x34, &x35, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x36, &x37, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x38, &x39, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x40, &x41, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x42, &x43, 0x0, x41, x38);
    fiat_p65376_addcarryx_u64(&x44, &x45, x43, x39, x36);
    fiat_p65376_addcarryx_u64(&x46, &x47, x45, x37, x34);
    fiat_p65376_addcarryx_u64(&x48, &x49, x47, x35, x32);
    fiat_p65376_addcarryx_u64(&x50, &x51, x49, x33, x30);
    x52 = (x51 + x31);
    fiat_p65376_addcarryx_u64(&x53, &x54, 0x0, x17, x40);
    fiat_p65376_addcarryx_u64(&x55, &x56, x54, x19, x42);
    fiat_p65376_addcarryx_u64(&x57, &x58, x56, x21, x44);
    fiat_p65376_addcarryx_u64(&x59, &x60, x58, x23, x46);
    fiat_p65376_addcarryx_u64(&x61, &x62, x60, x25, x48);
    fiat_p65376_addcarryx_u64(&x63, &x64, x62, x27, x50);
    fiat_p65376_addcarryx_u64(&x65, &x66, x64, x29, x52);
    fiat_p65376_mulx_u64(&x67, &x68, x1, (arg2[5]));
    fiat_p65376_mulx_u64(&x69, &x70, x1, (arg2[4]));
    fiat_p65376_mulx_u64(&x71, &x72, x1, (arg2[3]));
    fiat_p65376_mulx_u64(&x73, &x74, x1, (arg2[2]));
    fiat_p65376_mulx_u64(&x75, &x76, x1, (arg2[1]));
    fiat_p65376_mulx_u64(&x77, &x78, x1, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x79, &x80, 0x0, x78, x75);
    fiat_p65376_addcarryx_u64(&x81, &x82, x80, x76, x73);
    fiat_p65376_addcarryx_u64(&x83, &x84, x82, x74, x71);
    fiat_p65376_addcarryx_u64(&x85, &x86, x84, x72, x69);
    fiat_p65376_addcarryx_u64(&x87, &x88, x86, x70, x67);
    x89 = (x88 + x68);
    fiat_p65376_addcarryx_u64(&x90, &x91, 0x0, x55, x77);
    fiat_p65376_addcarryx_u64(&x92, &x93, x91, x57, x79);
    fiat_p65376_addcarryx_u64(&x94, &x95, x93, x59, x81);
    fiat_p65376_addcarryx_u64(&x96, &x97, x95, x61, x83);
    fiat_p65376_addcarryx_u64(&x98, &x99, x97, x63, x85);
    fiat_p65376_addcarryx_u64(&x100, &x101, x99, x65, x87);
    fiat_p65376_addcarryx_u64(&x102, &x103, x101, x66, x89);
    fiat_p65376_mulx_u64(&x104, &x105, x90, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x106, &x107, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x108, &x109, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x110, &x111, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x112, &x113, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x114, &x115, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x116, &x117, 0x0, x115, x112);
    fiat_p65376_addcarryx_u64(&x118, &x119, x117, x113, x110);
    fiat_p65376_addcarryx_u64(&x120, &x121, x119, x111, x108);
    fiat_p65376_addcarryx_u64(&x122, &x123, x121, x109, x106);
    fiat_p65376_addcarryx_u64(&x124, &x125, x123, x107, x104);
    x126 = (x125 + x105);
    fiat_p65376_addcarryx_u64(&x127, &x128, 0x0, x90, x114);
    fiat_p65376_addcarryx_u64(&x129, &x130, x128, x92, x116);
    fiat_p65376_addcarryx_u64(&x131, &x132, x130, x94, x118);
    fiat_p65376_addcarryx_u64(&x133, &x134, x132, x96, x120);
    fiat_p65376_addcarryx_u64(&x135, &x136, x134, x98, x122);
    fiat_p65376_addcarryx_u64(&x137, &x138, x136, x100, x124);
    fiat_p65376_addcarryx_u64(&x139, &x140, x138, x102, x126);
    x141 = ((uint64_t)x140 + x103);
    fiat_p65376_mulx_u64(&x142, &x143, x2, (arg2[5]));
    fiat_p65376_mulx_u64(&x144, &x145, x2, (arg2[4]));
    fiat_p65376_mulx_u64(&x146, &x147, x2, (arg2[3]));
    fiat_p65376_mulx_u64(&x148, &x149, x2, (arg2[2]));
    fiat_p65376_mulx_u64(&x150, &x151, x2, (arg2[1]));
    fiat_p65376_mulx_u64(&x152, &x153, x2, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x154, &x155, 0x0, x153, x150);
    fiat_p65376_addcarryx_u64(&x156, &x157, x155, x151, x148);
    fiat_p65376_addcarryx_u64(&x158, &x159, x157, x149, x146);
    fiat_p65376_addcarryx_u64(&x160, &x161, x159, x147, x144);
    fiat_p65376_addcarryx_u64(&x162, &x163, x161, x145, x142);
    x164 = (x163 + x143);
    fiat_p65376_addcarryx_u64(&x165, &x166, 0x0, x129, x152);
    fiat_p65376_addcarryx_u64(&x167, &x168, x166, x131, x154);
    fiat_p65376_addcarryx_u64(&x169, &x170, x168, x133, x156);
    fiat_p65376_addcarryx_u64(&x171, &x172, x170, x135, x158);
    fiat_p65376_addcarryx_u64(&x173, &x174, x172, x137, x160);
    fiat_p65376_addcarryx_u64(&x175, &x176, x174, x139, x162);
    fiat_p65376_addcarryx_u64(&x177, &x178, x176, x141, x164);
    fiat_p65376_mulx_u64(&x179, &x180, x165, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x181, &x182, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x183, &x184, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x185, &x186, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x187, &x188, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x189, &x190, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x191, &x192, 0x0, x190, x187);
    fiat_p65376_addcarryx_u64(&x193, &x194, x192, x188, x185);
    fiat_p65376_addcarryx_u64(&x195, &x196, x194, x186, x183);
    fiat_p65376_addcarryx_u64(&x197, &x198, x196, x184, x181);
    fiat_p65376_addcarryx_u64(&x199, &x200, x198, x182, x179);
    x201 = (x200 + x180);
    fiat_p65376_addcarryx_u64(&x202, &x203, 0x0, x165, x189);
    fiat_p65376_addcarryx_u64(&x204, &x205, x203, x167, x191);
    fiat_p65376_addcarryx_u64(&x206, &x207, x205, x169, x193);
    fiat_p65376_addcarryx_u64(&x208, &x209, x207, x171, x195);
    fiat_p65376_addcarryx_u64(&x210, &x211, x209, x173, x197);
    fiat_p65376_addcarryx_u64(&x212, &x213, x211, x175, x199);
    fiat_p65376_addcarryx_u64(&x214, &x215, x213, x177, x201);
    x216 = ((uint64_t)x215 + x178);
    fiat_p65376_mulx_u64(&x217, &x218, x3, (arg2[5]));
    fiat_p65376_mulx_u64(&x219, &x220, x3, (arg2[4]));
    fiat_p65376_mulx_u64(&x221, &x222, x3, (arg2[3]));
    fiat_p65376_mulx_u64(&x223, &x224, x3, (arg2[2]));
    fiat_p65376_mulx_u64(&x225, &x226, x3, (arg2[1]));
    fiat_p65376_mulx_u64(&x227, &x228, x3, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x229, &x230, 0x0, x228, x225);
    fiat_p65376_addcarryx_u64(&x231, &x232, x230, x226, x223);
    fiat_p65376_addcarryx_u64(&x233, &x234, x232, x224, x221);
    fiat_p65376_addcarryx_u64(&x235, &x236, x234, x222, x219);
    fiat_p65376_addcarryx_u64(&x237, &x238, x236, x220, x217);
    x239 = (x238 + x218);
    fiat_p65376_addcarryx_u64(&x240, &x241, 0x0, x204, x227);
    fiat_p65376_addcarryx_u64(&x242, &x243, x241, x206, x229);
    fiat_p65376_addcarryx_u64(&x244, &x245, x243, x208, x231);
    fiat_p65376_addcarryx_u64(&x246, &x247, x245, x210, x233);
    fiat_p65376_addcarryx_u64(&x248, &x249, x247, x212, x235);
    fiat_p65376_addcarryx_u64(&x250, &x251, x249, x214, x237);
    fiat_p65376_addcarryx_u64(&x252, &x253, x251, x216, x239);
    fiat_p65376_mulx_u64(&x254, &x255, x240, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x256, &x257, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x258, &x259, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x260, &x261, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x262, &x263, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x264, &x265, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x266, &x267, 0x0, x265, x262);
    fiat_p65376_addcarryx_u64(&x268, &x269, x267, x263, x260);
    fiat_p65376_addcarryx_u64(&x270, &x271, x269, x261, x258);
    fiat_p65376_addcarryx_u64(&x272, &x273, x271, x259, x256);
    fiat_p65376_addcarryx_u64(&x274, &x275, x273, x257, x254);
    x276 = (x275 + x255);
    fiat_p65376_addcarryx_u64(&x277, &x278, 0x0, x240, x264);
    fiat_p65376_addcarryx_u64(&x279, &x280, x278, x242, x266);
    fiat_p65376_addcarryx_u64(&x281, &x282, x280, x244, x268);
    fiat_p65376_addcarryx_u64(&x283, &x284, x282, x246, x270);
    fiat_p65376_addcarryx_u64(&x285, &x286, x284, x248, x272);
    fiat_p65376_addcarryx_u64(&x287, &x288, x286, x250, x274);
    fiat_p65376_addcarryx_u64(&x289, &x290, x288, x252, x276);
    x291 = ((uint64_t)x290 + x253);
    fiat_p65376_mulx_u64(&x292, &x293, x4, (arg2[5]));
    fiat_p65376_mulx_u64(&x294, &x295, x4, (arg2[4]));
    fiat_p65376_mulx_u64(&x296, &x297, x4, (arg2[3]));
    fiat_p65376_mulx_u64(&x298, &x299, x4, (arg2[2]));
    fiat_p65376_mulx_u64(&x300, &x301, x4, (arg2[1]));
    fiat_p65376_mulx_u64(&x302, &x303, x4, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x304, &x305, 0x0, x303, x300);
    fiat_p65376_addcarryx_u64(&x306, &x307, x305, x301, x298);
    fiat_p65376_addcarryx_u64(&x308, &x309, x307, x299, x296);
    fiat_p65376_addcarryx_u64(&x310, &x311, x309, x297, x294);
    fiat_p65376_addcarryx_u64(&x312, &x313, x311, x295, x292);
    x314 = (x313 + x293);
    fiat_p65376_addcarryx_u64(&x315, &x316, 0x0, x279, x302);
    fiat_p65376_addcarryx_u64(&x317, &x318, x316, x281, x304);
    fiat_p65376_addcarryx_u64(&x319, &x320, x318, x283, x306);
    fiat_p65376_addcarryx_u64(&x321, &x322, x320, x285, x308);
    fiat_p65376_addcarryx_u64(&x323, &x324, x322, x287, x310);
    fiat_p65376_addcarryx_u64(&x325, &x326, x324, x289, x312);
    fiat_p65376_addcarryx_u64(&x327, &x328, x326, x291, x314);
    fiat_p65376_mulx_u64(&x329, &x330, x315, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x331, &x332, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x333, &x334, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x335, &x336, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x337, &x338, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x339, &x340, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x341, &x342, 0x0, x340, x337);
    fiat_p65376_addcarryx_u64(&x343, &x344, x342, x338, x335);
    fiat_p65376_addcarryx_u64(&x345, &x346, x344, x336, x333);
    fiat_p65376_addcarryx_u64(&x347, &x348, x346, x334, x331);
    fiat_p65376_addcarryx_u64(&x349, &x350, x348, x332, x329);
    x351 = (x350 + x330);
    fiat_p65376_addcarryx_u64(&x352, &x353, 0x0, x315, x339);
    fiat_p65376_addcarryx_u64(&x354, &x355, x353, x317, x341);
    fiat_p65376_addcarryx_u64(&x356, &x357, x355, x319, x343);
    fiat_p65376_addcarryx_u64(&x358, &x359, x357, x321, x345);
    fiat_p65376_addcarryx_u64(&x360, &x361, x359, x323, x347);
    fiat_p65376_addcarryx_u64(&x362, &x363, x361, x325, x349);
    fiat_p65376_addcarryx_u64(&x364, &x365, x363, x327, x351);
    x366 = ((uint64_t)x365 + x328);
    fiat_p65376_mulx_u64(&x367, &x368, x5, (arg2[5]));
    fiat_p65376_mulx_u64(&x369, &x370, x5, (arg2[4]));
    fiat_p65376_mulx_u64(&x371, &x372, x5, (arg2[3]));
    fiat_p65376_mulx_u64(&x373, &x374, x5, (arg2[2]));
    fiat_p65376_mulx_u64(&x375, &x376, x5, (arg2[1]));
    fiat_p65376_mulx_u64(&x377, &x378, x5, (arg2[0]));
    fiat_p65376_addcarryx_u64(&x379, &x380, 0x0, x378, x375);
    fiat_p65376_addcarryx_u64(&x381, &x382, x380, x376, x373);
    fiat_p65376_addcarryx_u64(&x383, &x384, x382, x374, x371);
    fiat_p65376_addcarryx_u64(&x385, &x386, x384, x372, x369);
    fiat_p65376_addcarryx_u64(&x387, &x388, x386, x370, x367);
    x389 = (x388 + x368);
    fiat_p65376_addcarryx_u64(&x390, &x391, 0x0, x354, x377);
    fiat_p65376_addcarryx_u64(&x392, &x393, x391, x356, x379);
    fiat_p65376_addcarryx_u64(&x394, &x395, x393, x358, x381);
    fiat_p65376_addcarryx_u64(&x396, &x397, x395, x360, x383);
    fiat_p65376_addcarryx_u64(&x398, &x399, x397, x362, x385);
    fiat_p65376_addcarryx_u64(&x400, &x401, x399, x364, x387);
    fiat_p65376_addcarryx_u64(&x402, &x403, x401, x366, x389);
    fiat_p65376_mulx_u64(&x404, &x405, x390, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x406, &x407, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x408, &x409, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x410, &x411, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x412, &x413, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x414, &x415, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x416, &x417, 0x0, x415, x412);
    fiat_p65376_addcarryx_u64(&x418, &x419, x417, x413, x410);
    fiat_p65376_addcarryx_u64(&x420, &x421, x419, x411, x408);
    fiat_p65376_addcarryx_u64(&x422, &x423, x421, x409, x406);
    fiat_p65376_addcarryx_u64(&x424, &x425, x423, x407, x404);
    x426 = (x425 + x405);
    fiat_p65376_addcarryx_u64(&x427, &x428, 0x0, x390, x414);
    fiat_p65376_addcarryx_u64(&x429, &x430, x428, x392, x416);
    fiat_p65376_addcarryx_u64(&x431, &x432, x430, x394, x418);
    fiat_p65376_addcarryx_u64(&x433, &x434, x432, x396, x420);
    fiat_p65376_addcarryx_u64(&x435, &x436, x434, x398, x422);
    fiat_p65376_addcarryx_u64(&x437, &x438, x436, x400, x424);
    fiat_p65376_addcarryx_u64(&x439, &x440, x438, x402, x426);
    x441 = ((uint64_t)x440 + x403);
    fiat_p65376_subborrowx_u64(&x442, &x443, 0x0, x429, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x444, &x445, x443, x431, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x446, &x447, x445, x433, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x448, &x449, x447, x435, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x450, &x451, x449, x437, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x452, &x453, x451, x439, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x454, &x455, x453, x441, 0x0);
    fiat_p65376_cmovznz_u64(&x456, x455, x442, x429);
    fiat_p65376_cmovznz_u64(&x457, x455, x444, x431);
    fiat_p65376_cmovznz_u64(&x458, x455, x446, x433);
    fiat_p65376_cmovznz_u64(&x459, x455, x448, x435);
    fiat_p65376_cmovznz_u64(&x460, x455, x450, x437);
    fiat_p65376_cmovznz_u64(&x461, x455, x452, x439);
    out1[0] = x456;
    out1[1] = x457;
    out1[2] = x458;
    out1[3] = x459;
    out1[4] = x460;
    out1[5] = x461;
}

/*
 * The function fiat_p65376_square squares a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) * eval (from_montgomery arg1))
 * mod m 0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_square(fiat_p65376_montgomery_domain_field_element out1,
                   const fiat_p65376_montgomery_domain_field_element arg1)
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint64_t x7;
    uint64_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    uint64_t x15;
    uint64_t x16;
    uint64_t x17;
    uint64_t x18;
    uint64_t x19;
    fiat_p65376_uint1 x20;
    uint64_t x21;
    fiat_p65376_uint1 x22;
    uint64_t x23;
    fiat_p65376_uint1 x24;
    uint64_t x25;
    fiat_p65376_uint1 x26;
    uint64_t x27;
    fiat_p65376_uint1 x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint64_t x32;
    uint64_t x33;
    uint64_t x34;
    uint64_t x35;
    uint64_t x36;
    uint64_t x37;
    uint64_t x38;
    uint64_t x39;
    uint64_t x40;
    uint64_t x41;
    uint64_t x42;
    fiat_p65376_uint1 x43;
    uint64_t x44;
    fiat_p65376_uint1 x45;
    uint64_t x46;
    fiat_p65376_uint1 x47;
    uint64_t x48;
    fiat_p65376_uint1 x49;
    uint64_t x50;
    fiat_p65376_uint1 x51;
    uint64_t x52;
    uint64_t x53;
    fiat_p65376_uint1 x54;
    uint64_t x55;
    fiat_p65376_uint1 x56;
    uint64_t x57;
    fiat_p65376_uint1 x58;
    uint64_t x59;
    fiat_p65376_uint1 x60;
    uint64_t x61;
    fiat_p65376_uint1 x62;
    uint64_t x63;
    fiat_p65376_uint1 x64;
    uint64_t x65;
    fiat_p65376_uint1 x66;
    uint64_t x67;
    uint64_t x68;
    uint64_t x69;
    uint64_t x70;
    uint64_t x71;
    uint64_t x72;
    uint64_t x73;
    uint64_t x74;
    uint64_t x75;
    uint64_t x76;
    uint64_t x77;
    uint64_t x78;
    uint64_t x79;
    fiat_p65376_uint1 x80;
    uint64_t x81;
    fiat_p65376_uint1 x82;
    uint64_t x83;
    fiat_p65376_uint1 x84;
    uint64_t x85;
    fiat_p65376_uint1 x86;
    uint64_t x87;
    fiat_p65376_uint1 x88;
    uint64_t x89;
    uint64_t x90;
    fiat_p65376_uint1 x91;
    uint64_t x92;
    fiat_p65376_uint1 x93;
    uint64_t x94;
    fiat_p65376_uint1 x95;
    uint64_t x96;
    fiat_p65376_uint1 x97;
    uint64_t x98;
    fiat_p65376_uint1 x99;
    uint64_t x100;
    fiat_p65376_uint1 x101;
    uint64_t x102;
    fiat_p65376_uint1 x103;
    uint64_t x104;
    uint64_t x105;
    uint64_t x106;
    uint64_t x107;
    uint64_t x108;
    uint64_t x109;
    uint64_t x110;
    uint64_t x111;
    uint64_t x112;
    uint64_t x113;
    uint64_t x114;
    uint64_t x115;
    uint64_t x116;
    fiat_p65376_uint1 x117;
    uint64_t x118;
    fiat_p65376_uint1 x119;
    uint64_t x120;
    fiat_p65376_uint1 x121;
    uint64_t x122;
    fiat_p65376_uint1 x123;
    uint64_t x124;
    fiat_p65376_uint1 x125;
    uint64_t x126;
    uint64_t x127;
    fiat_p65376_uint1 x128;
    uint64_t x129;
    fiat_p65376_uint1 x130;
    uint64_t x131;
    fiat_p65376_uint1 x132;
    uint64_t x133;
    fiat_p65376_uint1 x134;
    uint64_t x135;
    fiat_p65376_uint1 x136;
    uint64_t x137;
    fiat_p65376_uint1 x138;
    uint64_t x139;
    fiat_p65376_uint1 x140;
    uint64_t x141;
    uint64_t x142;
    uint64_t x143;
    uint64_t x144;
    uint64_t x145;
    uint64_t x146;
    uint64_t x147;
    uint64_t x148;
    uint64_t x149;
    uint64_t x150;
    uint64_t x151;
    uint64_t x152;
    uint64_t x153;
    uint64_t x154;
    fiat_p65376_uint1 x155;
    uint64_t x156;
    fiat_p65376_uint1 x157;
    uint64_t x158;
    fiat_p65376_uint1 x159;
    uint64_t x160;
    fiat_p65376_uint1 x161;
    uint64_t x162;
    fiat_p65376_uint1 x163;
    uint64_t x164;
    uint64_t x165;
    fiat_p65376_uint1 x166;
    uint64_t x167;
    fiat_p65376_uint1 x168;
    uint64_t x169;
    fiat_p65376_uint1 x170;
    uint64_t x171;
    fiat_p65376_uint1 x172;
    uint64_t x173;
    fiat_p65376_uint1 x174;
    uint64_t x175;
    fiat_p65376_uint1 x176;
    uint64_t x177;
    fiat_p65376_uint1 x178;
    uint64_t x179;
    uint64_t x180;
    uint64_t x181;
    uint64_t x182;
    uint64_t x183;
    uint64_t x184;
    uint64_t x185;
    uint64_t x186;
    uint64_t x187;
    uint64_t x188;
    uint64_t x189;
    uint64_t x190;
    uint64_t x191;
    fiat_p65376_uint1 x192;
    uint64_t x193;
    fiat_p65376_uint1 x194;
    uint64_t x195;
    fiat_p65376_uint1 x196;
    uint64_t x197;
    fiat_p65376_uint1 x198;
    uint64_t x199;
    fiat_p65376_uint1 x200;
    uint64_t x201;
    uint64_t x202;
    fiat_p65376_uint1 x203;
    uint64_t x204;
    fiat_p65376_uint1 x205;
    uint64_t x206;
    fiat_p65376_uint1 x207;
    uint64_t x208;
    fiat_p65376_uint1 x209;
    uint64_t x210;
    fiat_p65376_uint1 x211;
    uint64_t x212;
    fiat_p65376_uint1 x213;
    uint64_t x214;
    fiat_p65376_uint1 x215;
    uint64_t x216;
    uint64_t x217;
    uint64_t x218;
    uint64_t x219;
    uint64_t x220;
    uint64_t x221;
    uint64_t x222;
    uint64_t x223;
    uint64_t x224;
    uint64_t x225;
    uint64_t x226;
    uint64_t x227;
    uint64_t x228;
    uint64_t x229;
    fiat_p65376_uint1 x230;
    uint64_t x231;
    fiat_p65376_uint1 x232;
    uint64_t x233;
    fiat_p65376_uint1 x234;
    uint64_t x235;
    fiat_p65376_uint1 x236;
    uint64_t x237;
    fiat_p65376_uint1 x238;
    uint64_t x239;
    uint64_t x240;
    fiat_p65376_uint1 x241;
    uint64_t x242;
    fiat_p65376_uint1 x243;
    uint64_t x244;
    fiat_p65376_uint1 x245;
    uint64_t x246;
    fiat_p65376_uint1 x247;
    uint64_t x248;
    fiat_p65376_uint1 x249;
    uint64_t x250;
    fiat_p65376_uint1 x251;
    uint64_t x252;
    fiat_p65376_uint1 x253;
    uint64_t x254;
    uint64_t x255;
    uint64_t x256;
    uint64_t x257;
    uint64_t x258;
    uint64_t x259;
    uint64_t x260;
    uint64_t x261;
    uint64_t x262;
    uint64_t x263;
    uint64_t x264;
    uint64_t x265;
    uint64_t x266;
    fiat_p65376_uint1 x267;
    uint64_t x268;
    fiat_p65376_uint1 x269;
    uint64_t x270;
    fiat_p65376_uint1 x271;
    uint64_t x272;
    fiat_p65376_uint1 x273;
    uint64_t x274;
    fiat_p65376_uint1 x275;
    uint64_t x276;
    uint64_t x277;
    fiat_p65376_uint1 x278;
    uint64_t x279;
    fiat_p65376_uint1 x280;
    uint64_t x281;
    fiat_p65376_uint1 x282;
    uint64_t x283;
    fiat_p65376_uint1 x284;
    uint64_t x285;
    fiat_p65376_uint1 x286;
    uint64_t x287;
    fiat_p65376_uint1 x288;
    uint64_t x289;
    fiat_p65376_uint1 x290;
    uint64_t x291;
    uint64_t x292;
    uint64_t x293;
    uint64_t x294;
    uint64_t x295;
    uint64_t x296;
    uint64_t x297;
    uint64_t x298;
    uint64_t x299;
    uint64_t x300;
    uint64_t x301;
    uint64_t x302;
    uint64_t x303;
    uint64_t x304;
    fiat_p65376_uint1 x305;
    uint64_t x306;
    fiat_p65376_uint1 x307;
    uint64_t x308;
    fiat_p65376_uint1 x309;
    uint64_t x310;
    fiat_p65376_uint1 x311;
    uint64_t x312;
    fiat_p65376_uint1 x313;
    uint64_t x314;
    uint64_t x315;
    fiat_p65376_uint1 x316;
    uint64_t x317;
    fiat_p65376_uint1 x318;
    uint64_t x319;
    fiat_p65376_uint1 x320;
    uint64_t x321;
    fiat_p65376_uint1 x322;
    uint64_t x323;
    fiat_p65376_uint1 x324;
    uint64_t x325;
    fiat_p65376_uint1 x326;
    uint64_t x327;
    fiat_p65376_uint1 x328;
    uint64_t x329;
    uint64_t x330;
    uint64_t x331;
    uint64_t x332;
    uint64_t x333;
    uint64_t x334;
    uint64_t x335;
    uint64_t x336;
    uint64_t x337;
    uint64_t x338;
    uint64_t x339;
    uint64_t x340;
    uint64_t x341;
    fiat_p65376_uint1 x342;
    uint64_t x343;
    fiat_p65376_uint1 x344;
    uint64_t x345;
    fiat_p65376_uint1 x346;
    uint64_t x347;
    fiat_p65376_uint1 x348;
    uint64_t x349;
    fiat_p65376_uint1 x350;
    uint64_t x351;
    uint64_t x352;
    fiat_p65376_uint1 x353;
    uint64_t x354;
    fiat_p65376_uint1 x355;
    uint64_t x356;
    fiat_p65376_uint1 x357;
    uint64_t x358;
    fiat_p65376_uint1 x359;
    uint64_t x360;
    fiat_p65376_uint1 x361;
    uint64_t x362;
    fiat_p65376_uint1 x363;
    uint64_t x364;
    fiat_p65376_uint1 x365;
    uint64_t x366;
    uint64_t x367;
    uint64_t x368;
    uint64_t x369;
    uint64_t x370;
    uint64_t x371;
    uint64_t x372;
    uint64_t x373;
    uint64_t x374;
    uint64_t x375;
    uint64_t x376;
    uint64_t x377;
    uint64_t x378;
    uint64_t x379;
    fiat_p65376_uint1 x380;
    uint64_t x381;
    fiat_p65376_uint1 x382;
    uint64_t x383;
    fiat_p65376_uint1 x384;
    uint64_t x385;
    fiat_p65376_uint1 x386;
    uint64_t x387;
    fiat_p65376_uint1 x388;
    uint64_t x389;
    uint64_t x390;
    fiat_p65376_uint1 x391;
    uint64_t x392;
    fiat_p65376_uint1 x393;
    uint64_t x394;
    fiat_p65376_uint1 x395;
    uint64_t x396;
    fiat_p65376_uint1 x397;
    uint64_t x398;
    fiat_p65376_uint1 x399;
    uint64_t x400;
    fiat_p65376_uint1 x401;
    uint64_t x402;
    fiat_p65376_uint1 x403;
    uint64_t x404;
    uint64_t x405;
    uint64_t x406;
    uint64_t x407;
    uint64_t x408;
    uint64_t x409;
    uint64_t x410;
    uint64_t x411;
    uint64_t x412;
    uint64_t x413;
    uint64_t x414;
    uint64_t x415;
    uint64_t x416;
    fiat_p65376_uint1 x417;
    uint64_t x418;
    fiat_p65376_uint1 x419;
    uint64_t x420;
    fiat_p65376_uint1 x421;
    uint64_t x422;
    fiat_p65376_uint1 x423;
    uint64_t x424;
    fiat_p65376_uint1 x425;
    uint64_t x426;
    uint64_t x427;
    fiat_p65376_uint1 x428;
    uint64_t x429;
    fiat_p65376_uint1 x430;
    uint64_t x431;
    fiat_p65376_uint1 x432;
    uint64_t x433;
    fiat_p65376_uint1 x434;
    uint64_t x435;
    fiat_p65376_uint1 x436;
    uint64_t x437;
    fiat_p65376_uint1 x438;
    uint64_t x439;
    fiat_p65376_uint1 x440;
    uint64_t x441;
    uint64_t x442;
    fiat_p65376_uint1 x443;
    uint64_t x444;
    fiat_p65376_uint1 x445;
    uint64_t x446;
    fiat_p65376_uint1 x447;
    uint64_t x448;
    fiat_p65376_uint1 x449;
    uint64_t x450;
    fiat_p65376_uint1 x451;
    uint64_t x452;
    fiat_p65376_uint1 x453;
    uint64_t x454;
    fiat_p65376_uint1 x455;
    uint64_t x456;
    uint64_t x457;
    uint64_t x458;
    uint64_t x459;
    uint64_t x460;
    uint64_t x461;
    x1 = (arg1[1]);
    x2 = (arg1[2]);
    x3 = (arg1[3]);
    x4 = (arg1[4]);
    x5 = (arg1[5]);
    x6 = (arg1[0]);
    fiat_p65376_mulx_u64(&x7, &x8, x6, (arg1[5]));
    fiat_p65376_mulx_u64(&x9, &x10, x6, (arg1[4]));
    fiat_p65376_mulx_u64(&x11, &x12, x6, (arg1[3]));
    fiat_p65376_mulx_u64(&x13, &x14, x6, (arg1[2]));
    fiat_p65376_mulx_u64(&x15, &x16, x6, (arg1[1]));
    fiat_p65376_mulx_u64(&x17, &x18, x6, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x19, &x20, 0x0, x18, x15);
    fiat_p65376_addcarryx_u64(&x21, &x22, x20, x16, x13);
    fiat_p65376_addcarryx_u64(&x23, &x24, x22, x14, x11);
    fiat_p65376_addcarryx_u64(&x25, &x26, x24, x12, x9);
    fiat_p65376_addcarryx_u64(&x27, &x28, x26, x10, x7);
    x29 = (x28 + x8);
    fiat_p65376_mulx_u64(&x30, &x31, x17, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x32, &x33, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x34, &x35, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x36, &x37, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x38, &x39, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x40, &x41, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x42, &x43, 0x0, x41, x38);
    fiat_p65376_addcarryx_u64(&x44, &x45, x43, x39, x36);
    fiat_p65376_addcarryx_u64(&x46, &x47, x45, x37, x34);
    fiat_p65376_addcarryx_u64(&x48, &x49, x47, x35, x32);
    fiat_p65376_addcarryx_u64(&x50, &x51, x49, x33, x30);
    x52 = (x51 + x31);
    fiat_p65376_addcarryx_u64(&x53, &x54, 0x0, x17, x40);
    fiat_p65376_addcarryx_u64(&x55, &x56, x54, x19, x42);
    fiat_p65376_addcarryx_u64(&x57, &x58, x56, x21, x44);
    fiat_p65376_addcarryx_u64(&x59, &x60, x58, x23, x46);
    fiat_p65376_addcarryx_u64(&x61, &x62, x60, x25, x48);
    fiat_p65376_addcarryx_u64(&x63, &x64, x62, x27, x50);
    fiat_p65376_addcarryx_u64(&x65, &x66, x64, x29, x52);
    fiat_p65376_mulx_u64(&x67, &x68, x1, (arg1[5]));
    fiat_p65376_mulx_u64(&x69, &x70, x1, (arg1[4]));
    fiat_p65376_mulx_u64(&x71, &x72, x1, (arg1[3]));
    fiat_p65376_mulx_u64(&x73, &x74, x1, (arg1[2]));
    fiat_p65376_mulx_u64(&x75, &x76, x1, (arg1[1]));
    fiat_p65376_mulx_u64(&x77, &x78, x1, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x79, &x80, 0x0, x78, x75);
    fiat_p65376_addcarryx_u64(&x81, &x82, x80, x76, x73);
    fiat_p65376_addcarryx_u64(&x83, &x84, x82, x74, x71);
    fiat_p65376_addcarryx_u64(&x85, &x86, x84, x72, x69);
    fiat_p65376_addcarryx_u64(&x87, &x88, x86, x70, x67);
    x89 = (x88 + x68);
    fiat_p65376_addcarryx_u64(&x90, &x91, 0x0, x55, x77);
    fiat_p65376_addcarryx_u64(&x92, &x93, x91, x57, x79);
    fiat_p65376_addcarryx_u64(&x94, &x95, x93, x59, x81);
    fiat_p65376_addcarryx_u64(&x96, &x97, x95, x61, x83);
    fiat_p65376_addcarryx_u64(&x98, &x99, x97, x63, x85);
    fiat_p65376_addcarryx_u64(&x100, &x101, x99, x65, x87);
    fiat_p65376_addcarryx_u64(&x102, &x103, x101, x66, x89);
    fiat_p65376_mulx_u64(&x104, &x105, x90, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x106, &x107, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x108, &x109, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x110, &x111, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x112, &x113, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x114, &x115, x90, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x116, &x117, 0x0, x115, x112);
    fiat_p65376_addcarryx_u64(&x118, &x119, x117, x113, x110);
    fiat_p65376_addcarryx_u64(&x120, &x121, x119, x111, x108);
    fiat_p65376_addcarryx_u64(&x122, &x123, x121, x109, x106);
    fiat_p65376_addcarryx_u64(&x124, &x125, x123, x107, x104);
    x126 = (x125 + x105);
    fiat_p65376_addcarryx_u64(&x127, &x128, 0x0, x90, x114);
    fiat_p65376_addcarryx_u64(&x129, &x130, x128, x92, x116);
    fiat_p65376_addcarryx_u64(&x131, &x132, x130, x94, x118);
    fiat_p65376_addcarryx_u64(&x133, &x134, x132, x96, x120);
    fiat_p65376_addcarryx_u64(&x135, &x136, x134, x98, x122);
    fiat_p65376_addcarryx_u64(&x137, &x138, x136, x100, x124);
    fiat_p65376_addcarryx_u64(&x139, &x140, x138, x102, x126);
    x141 = ((uint64_t)x140 + x103);
    fiat_p65376_mulx_u64(&x142, &x143, x2, (arg1[5]));
    fiat_p65376_mulx_u64(&x144, &x145, x2, (arg1[4]));
    fiat_p65376_mulx_u64(&x146, &x147, x2, (arg1[3]));
    fiat_p65376_mulx_u64(&x148, &x149, x2, (arg1[2]));
    fiat_p65376_mulx_u64(&x150, &x151, x2, (arg1[1]));
    fiat_p65376_mulx_u64(&x152, &x153, x2, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x154, &x155, 0x0, x153, x150);
    fiat_p65376_addcarryx_u64(&x156, &x157, x155, x151, x148);
    fiat_p65376_addcarryx_u64(&x158, &x159, x157, x149, x146);
    fiat_p65376_addcarryx_u64(&x160, &x161, x159, x147, x144);
    fiat_p65376_addcarryx_u64(&x162, &x163, x161, x145, x142);
    x164 = (x163 + x143);
    fiat_p65376_addcarryx_u64(&x165, &x166, 0x0, x129, x152);
    fiat_p65376_addcarryx_u64(&x167, &x168, x166, x131, x154);
    fiat_p65376_addcarryx_u64(&x169, &x170, x168, x133, x156);
    fiat_p65376_addcarryx_u64(&x171, &x172, x170, x135, x158);
    fiat_p65376_addcarryx_u64(&x173, &x174, x172, x137, x160);
    fiat_p65376_addcarryx_u64(&x175, &x176, x174, x139, x162);
    fiat_p65376_addcarryx_u64(&x177, &x178, x176, x141, x164);
    fiat_p65376_mulx_u64(&x179, &x180, x165, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x181, &x182, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x183, &x184, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x185, &x186, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x187, &x188, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x189, &x190, x165, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x191, &x192, 0x0, x190, x187);
    fiat_p65376_addcarryx_u64(&x193, &x194, x192, x188, x185);
    fiat_p65376_addcarryx_u64(&x195, &x196, x194, x186, x183);
    fiat_p65376_addcarryx_u64(&x197, &x198, x196, x184, x181);
    fiat_p65376_addcarryx_u64(&x199, &x200, x198, x182, x179);
    x201 = (x200 + x180);
    fiat_p65376_addcarryx_u64(&x202, &x203, 0x0, x165, x189);
    fiat_p65376_addcarryx_u64(&x204, &x205, x203, x167, x191);
    fiat_p65376_addcarryx_u64(&x206, &x207, x205, x169, x193);
    fiat_p65376_addcarryx_u64(&x208, &x209, x207, x171, x195);
    fiat_p65376_addcarryx_u64(&x210, &x211, x209, x173, x197);
    fiat_p65376_addcarryx_u64(&x212, &x213, x211, x175, x199);
    fiat_p65376_addcarryx_u64(&x214, &x215, x213, x177, x201);
    x216 = ((uint64_t)x215 + x178);
    fiat_p65376_mulx_u64(&x217, &x218, x3, (arg1[5]));
    fiat_p65376_mulx_u64(&x219, &x220, x3, (arg1[4]));
    fiat_p65376_mulx_u64(&x221, &x222, x3, (arg1[3]));
    fiat_p65376_mulx_u64(&x223, &x224, x3, (arg1[2]));
    fiat_p65376_mulx_u64(&x225, &x226, x3, (arg1[1]));
    fiat_p65376_mulx_u64(&x227, &x228, x3, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x229, &x230, 0x0, x228, x225);
    fiat_p65376_addcarryx_u64(&x231, &x232, x230, x226, x223);
    fiat_p65376_addcarryx_u64(&x233, &x234, x232, x224, x221);
    fiat_p65376_addcarryx_u64(&x235, &x236, x234, x222, x219);
    fiat_p65376_addcarryx_u64(&x237, &x238, x236, x220, x217);
    x239 = (x238 + x218);
    fiat_p65376_addcarryx_u64(&x240, &x241, 0x0, x204, x227);
    fiat_p65376_addcarryx_u64(&x242, &x243, x241, x206, x229);
    fiat_p65376_addcarryx_u64(&x244, &x245, x243, x208, x231);
    fiat_p65376_addcarryx_u64(&x246, &x247, x245, x210, x233);
    fiat_p65376_addcarryx_u64(&x248, &x249, x247, x212, x235);
    fiat_p65376_addcarryx_u64(&x250, &x251, x249, x214, x237);
    fiat_p65376_addcarryx_u64(&x252, &x253, x251, x216, x239);
    fiat_p65376_mulx_u64(&x254, &x255, x240, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x256, &x257, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x258, &x259, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x260, &x261, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x262, &x263, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x264, &x265, x240, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x266, &x267, 0x0, x265, x262);
    fiat_p65376_addcarryx_u64(&x268, &x269, x267, x263, x260);
    fiat_p65376_addcarryx_u64(&x270, &x271, x269, x261, x258);
    fiat_p65376_addcarryx_u64(&x272, &x273, x271, x259, x256);
    fiat_p65376_addcarryx_u64(&x274, &x275, x273, x257, x254);
    x276 = (x275 + x255);
    fiat_p65376_addcarryx_u64(&x277, &x278, 0x0, x240, x264);
    fiat_p65376_addcarryx_u64(&x279, &x280, x278, x242, x266);
    fiat_p65376_addcarryx_u64(&x281, &x282, x280, x244, x268);
    fiat_p65376_addcarryx_u64(&x283, &x284, x282, x246, x270);
    fiat_p65376_addcarryx_u64(&x285, &x286, x284, x248, x272);
    fiat_p65376_addcarryx_u64(&x287, &x288, x286, x250, x274);
    fiat_p65376_addcarryx_u64(&x289, &x290, x288, x252, x276);
    x291 = ((uint64_t)x290 + x253);
    fiat_p65376_mulx_u64(&x292, &x293, x4, (arg1[5]));
    fiat_p65376_mulx_u64(&x294, &x295, x4, (arg1[4]));
    fiat_p65376_mulx_u64(&x296, &x297, x4, (arg1[3]));
    fiat_p65376_mulx_u64(&x298, &x299, x4, (arg1[2]));
    fiat_p65376_mulx_u64(&x300, &x301, x4, (arg1[1]));
    fiat_p65376_mulx_u64(&x302, &x303, x4, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x304, &x305, 0x0, x303, x300);
    fiat_p65376_addcarryx_u64(&x306, &x307, x305, x301, x298);
    fiat_p65376_addcarryx_u64(&x308, &x309, x307, x299, x296);
    fiat_p65376_addcarryx_u64(&x310, &x311, x309, x297, x294);
    fiat_p65376_addcarryx_u64(&x312, &x313, x311, x295, x292);
    x314 = (x313 + x293);
    fiat_p65376_addcarryx_u64(&x315, &x316, 0x0, x279, x302);
    fiat_p65376_addcarryx_u64(&x317, &x318, x316, x281, x304);
    fiat_p65376_addcarryx_u64(&x319, &x320, x318, x283, x306);
    fiat_p65376_addcarryx_u64(&x321, &x322, x320, x285, x308);
    fiat_p65376_addcarryx_u64(&x323, &x324, x322, x287, x310);
    fiat_p65376_addcarryx_u64(&x325, &x326, x324, x289, x312);
    fiat_p65376_addcarryx_u64(&x327, &x328, x326, x291, x314);
    fiat_p65376_mulx_u64(&x329, &x330, x315, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x331, &x332, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x333, &x334, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x335, &x336, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x337, &x338, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x339, &x340, x315, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x341, &x342, 0x0, x340, x337);
    fiat_p65376_addcarryx_u64(&x343, &x344, x342, x338, x335);
    fiat_p65376_addcarryx_u64(&x345, &x346, x344, x336, x333);
    fiat_p65376_addcarryx_u64(&x347, &x348, x346, x334, x331);
    fiat_p65376_addcarryx_u64(&x349, &x350, x348, x332, x329);
    x351 = (x350 + x330);
    fiat_p65376_addcarryx_u64(&x352, &x353, 0x0, x315, x339);
    fiat_p65376_addcarryx_u64(&x354, &x355, x353, x317, x341);
    fiat_p65376_addcarryx_u64(&x356, &x357, x355, x319, x343);
    fiat_p65376_addcarryx_u64(&x358, &x359, x357, x321, x345);
    fiat_p65376_addcarryx_u64(&x360, &x361, x359, x323, x347);
    fiat_p65376_addcarryx_u64(&x362, &x363, x361, x325, x349);
    fiat_p65376_addcarryx_u64(&x364, &x365, x363, x327, x351);
    x366 = ((uint64_t)x365 + x328);
    fiat_p65376_mulx_u64(&x367, &x368, x5, (arg1[5]));
    fiat_p65376_mulx_u64(&x369, &x370, x5, (arg1[4]));
    fiat_p65376_mulx_u64(&x371, &x372, x5, (arg1[3]));
    fiat_p65376_mulx_u64(&x373, &x374, x5, (arg1[2]));
    fiat_p65376_mulx_u64(&x375, &x376, x5, (arg1[1]));
    fiat_p65376_mulx_u64(&x377, &x378, x5, (arg1[0]));
    fiat_p65376_addcarryx_u64(&x379, &x380, 0x0, x378, x375);
    fiat_p65376_addcarryx_u64(&x381, &x382, x380, x376, x373);
    fiat_p65376_addcarryx_u64(&x383, &x384, x382, x374, x371);
    fiat_p65376_addcarryx_u64(&x385, &x386, x384, x372, x369);
    fiat_p65376_addcarryx_u64(&x387, &x388, x386, x370, x367);
    x389 = (x388 + x368);
    fiat_p65376_addcarryx_u64(&x390, &x391, 0x0, x354, x377);
    fiat_p65376_addcarryx_u64(&x392, &x393, x391, x356, x379);
    fiat_p65376_addcarryx_u64(&x394, &x395, x393, x358, x381);
    fiat_p65376_addcarryx_u64(&x396, &x397, x395, x360, x383);
    fiat_p65376_addcarryx_u64(&x398, &x399, x397, x362, x385);
    fiat_p65376_addcarryx_u64(&x400, &x401, x399, x364, x387);
    fiat_p65376_addcarryx_u64(&x402, &x403, x401, x366, x389);
    fiat_p65376_mulx_u64(&x404, &x405, x390, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x406, &x407, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x408, &x409, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x410, &x411, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x412, &x413, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x414, &x415, x390, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x416, &x417, 0x0, x415, x412);
    fiat_p65376_addcarryx_u64(&x418, &x419, x417, x413, x410);
    fiat_p65376_addcarryx_u64(&x420, &x421, x419, x411, x408);
    fiat_p65376_addcarryx_u64(&x422, &x423, x421, x409, x406);
    fiat_p65376_addcarryx_u64(&x424, &x425, x423, x407, x404);
    x426 = (x425 + x405);
    fiat_p65376_addcarryx_u64(&x427, &x428, 0x0, x390, x414);
    fiat_p65376_addcarryx_u64(&x429, &x430, x428, x392, x416);
    fiat_p65376_addcarryx_u64(&x431, &x432, x430, x394, x418);
    fiat_p65376_addcarryx_u64(&x433, &x434, x432, x396, x420);
    fiat_p65376_addcarryx_u64(&x435, &x436, x434, x398, x422);
    fiat_p65376_addcarryx_u64(&x437, &x438, x436, x400, x424);
    fiat_p65376_addcarryx_u64(&x439, &x440, x438, x402, x426);
    x441 = ((uint64_t)x440 + x403);
    fiat_p65376_subborrowx_u64(&x442, &x443, 0x0, x429, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x444, &x445, x443, x431, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x446, &x447, x445, x433, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x448, &x449, x447, x435, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x450, &x451, x449, x437, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x452, &x453, x451, x439, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x454, &x455, x453, x441, 0x0);
    fiat_p65376_cmovznz_u64(&x456, x455, x442, x429);
    fiat_p65376_cmovznz_u64(&x457, x455, x444, x431);
    fiat_p65376_cmovznz_u64(&x458, x455, x446, x433);
    fiat_p65376_cmovznz_u64(&x459, x455, x448, x435);
    fiat_p65376_cmovznz_u64(&x460, x455, x450, x437);
    fiat_p65376_cmovznz_u64(&x461, x455, x452, x439);
    out1[0] = x456;
    out1[1] = x457;
    out1[2] = x458;
    out1[3] = x459;
    out1[4] = x460;
    out1[5] = x461;
}

/*
 * The function fiat_p65376_add adds two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) + eval (from_montgomery arg2))
 * mod m 0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_add(fiat_p65376_montgomery_domain_field_element out1,
                const fiat_p65376_montgomery_domain_field_element arg1,
                const fiat_p65376_montgomery_domain_field_element arg2)
{
    uint64_t x1;
    fiat_p65376_uint1 x2;
    uint64_t x3;
    fiat_p65376_uint1 x4;
    uint64_t x5;
    fiat_p65376_uint1 x6;
    uint64_t x7;
    fiat_p65376_uint1 x8;
    uint64_t x9;
    fiat_p65376_uint1 x10;
    uint64_t x11;
    fiat_p65376_uint1 x12;
    uint64_t x13;
    fiat_p65376_uint1 x14;
    uint64_t x15;
    fiat_p65376_uint1 x16;
    uint64_t x17;
    fiat_p65376_uint1 x18;
    uint64_t x19;
    fiat_p65376_uint1 x20;
    uint64_t x21;
    fiat_p65376_uint1 x22;
    uint64_t x23;
    fiat_p65376_uint1 x24;
    uint64_t x25;
    fiat_p65376_uint1 x26;
    uint64_t x27;
    uint64_t x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint64_t x32;
    fiat_p65376_addcarryx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
    fiat_p65376_addcarryx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
    fiat_p65376_addcarryx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
    fiat_p65376_addcarryx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
    fiat_p65376_addcarryx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
    fiat_p65376_addcarryx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
    fiat_p65376_subborrowx_u64(&x13, &x14, 0x0, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x15, &x16, x14, x3, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x17, &x18, x16, x5, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x19, &x20, x18, x7, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x21, &x22, x20, x9, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x23, &x24, x22, x11, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x25, &x26, x24, x12, 0x0);
    fiat_p65376_cmovznz_u64(&x27, x26, x13, x1);
    fiat_p65376_cmovznz_u64(&x28, x26, x15, x3);
    fiat_p65376_cmovznz_u64(&x29, x26, x17, x5);
    fiat_p65376_cmovznz_u64(&x30, x26, x19, x7);
    fiat_p65376_cmovznz_u64(&x31, x26, x21, x9);
    fiat_p65376_cmovznz_u64(&x32, x26, x23, x11);
    out1[0] = x27;
    out1[1] = x28;
    out1[2] = x29;
    out1[3] = x30;
    out1[4] = x31;
    out1[5] = x32;
}

/*
 * The function fiat_p65376_sub subtracts two field elements in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 *   0 ≤ eval arg2 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = (eval (from_montgomery arg1) - eval (from_montgomery arg2))
 * mod m 0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_sub(fiat_p65376_montgomery_domain_field_element out1,
                const fiat_p65376_montgomery_domain_field_element arg1,
                const fiat_p65376_montgomery_domain_field_element arg2)
{
    uint64_t x1;
    fiat_p65376_uint1 x2;
    uint64_t x3;
    fiat_p65376_uint1 x4;
    uint64_t x5;
    fiat_p65376_uint1 x6;
    uint64_t x7;
    fiat_p65376_uint1 x8;
    uint64_t x9;
    fiat_p65376_uint1 x10;
    uint64_t x11;
    fiat_p65376_uint1 x12;
    uint64_t x13;
    uint64_t x14;
    fiat_p65376_uint1 x15;
    uint64_t x16;
    fiat_p65376_uint1 x17;
    uint64_t x18;
    fiat_p65376_uint1 x19;
    uint64_t x20;
    fiat_p65376_uint1 x21;
    uint64_t x22;
    fiat_p65376_uint1 x23;
    uint64_t x24;
    fiat_p65376_uint1 x25;
    fiat_p65376_subborrowx_u64(&x1, &x2, 0x0, (arg1[0]), (arg2[0]));
    fiat_p65376_subborrowx_u64(&x3, &x4, x2, (arg1[1]), (arg2[1]));
    fiat_p65376_subborrowx_u64(&x5, &x6, x4, (arg1[2]), (arg2[2]));
    fiat_p65376_subborrowx_u64(&x7, &x8, x6, (arg1[3]), (arg2[3]));
    fiat_p65376_subborrowx_u64(&x9, &x10, x8, (arg1[4]), (arg2[4]));
    fiat_p65376_subborrowx_u64(&x11, &x12, x10, (arg1[5]), (arg2[5]));
    fiat_p65376_cmovznz_u64(&x13, x12, 0x0, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x14, &x15, 0x0, x1, x13);
    fiat_p65376_addcarryx_u64(&x16, &x17, x15, x3, x13);
    fiat_p65376_addcarryx_u64(&x18, &x19, x17, x5, x13);
    fiat_p65376_addcarryx_u64(&x20, &x21, x19, x7, x13);
    fiat_p65376_addcarryx_u64(&x22, &x23, x21, x9, x13);
    fiat_p65376_addcarryx_u64(&x24, &x25, x23, x11, (x13 & UINT64_C(0x40ffffffffffffff)));
    out1[0] = x14;
    out1[1] = x16;
    out1[2] = x18;
    out1[3] = x20;
    out1[4] = x22;
    out1[5] = x24;
}

/*
 * The function fiat_p65376_opp negates a field element in the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = -eval (from_montgomery arg1) mod m
 *   0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_opp(fiat_p65376_montgomery_domain_field_element out1,
                const fiat_p65376_montgomery_domain_field_element arg1)
{
    uint64_t x1;
    fiat_p65376_uint1 x2;
    uint64_t x3;
    fiat_p65376_uint1 x4;
    uint64_t x5;
    fiat_p65376_uint1 x6;
    uint64_t x7;
    fiat_p65376_uint1 x8;
    uint64_t x9;
    fiat_p65376_uint1 x10;
    uint64_t x11;
    fiat_p65376_uint1 x12;
    uint64_t x13;
    uint64_t x14;
    fiat_p65376_uint1 x15;
    uint64_t x16;
    fiat_p65376_uint1 x17;
    uint64_t x18;
    fiat_p65376_uint1 x19;
    uint64_t x20;
    fiat_p65376_uint1 x21;
    uint64_t x22;
    fiat_p65376_uint1 x23;
    uint64_t x24;
    fiat_p65376_uint1 x25;
    fiat_p65376_subborrowx_u64(&x1, &x2, 0x0, 0x0, (arg1[0]));
    fiat_p65376_subborrowx_u64(&x3, &x4, x2, 0x0, (arg1[1]));
    fiat_p65376_subborrowx_u64(&x5, &x6, x4, 0x0, (arg1[2]));
    fiat_p65376_subborrowx_u64(&x7, &x8, x6, 0x0, (arg1[3]));
    fiat_p65376_subborrowx_u64(&x9, &x10, x8, 0x0, (arg1[4]));
    fiat_p65376_subborrowx_u64(&x11, &x12, x10, 0x0, (arg1[5]));
    fiat_p65376_cmovznz_u64(&x13, x12, 0x0, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x14, &x15, 0x0, x1, x13);
    fiat_p65376_addcarryx_u64(&x16, &x17, x15, x3, x13);
    fiat_p65376_addcarryx_u64(&x18, &x19, x17, x5, x13);
    fiat_p65376_addcarryx_u64(&x20, &x21, x19, x7, x13);
    fiat_p65376_addcarryx_u64(&x22, &x23, x21, x9, x13);
    fiat_p65376_addcarryx_u64(&x24, &x25, x23, x11, (x13 & UINT64_C(0x40ffffffffffffff)));
    out1[0] = x14;
    out1[1] = x16;
    out1[2] = x18;
    out1[3] = x20;
    out1[4] = x22;
    out1[5] = x24;
}

/*
 * The function fiat_p65376_from_montgomery translates a field element out of the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = (eval arg1 * ((2^64)⁻¹ mod m)^6) mod m
 *   0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_from_montgomery(fiat_p65376_non_montgomery_domain_field_element out1,
                            const fiat_p65376_montgomery_domain_field_element arg1)
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint64_t x7;
    uint64_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    fiat_p65376_uint1 x15;
    uint64_t x16;
    fiat_p65376_uint1 x17;
    uint64_t x18;
    fiat_p65376_uint1 x19;
    uint64_t x20;
    fiat_p65376_uint1 x21;
    uint64_t x22;
    fiat_p65376_uint1 x23;
    uint64_t x24;
    fiat_p65376_uint1 x25;
    uint64_t x26;
    fiat_p65376_uint1 x27;
    uint64_t x28;
    fiat_p65376_uint1 x29;
    uint64_t x30;
    fiat_p65376_uint1 x31;
    uint64_t x32;
    fiat_p65376_uint1 x33;
    uint64_t x34;
    fiat_p65376_uint1 x35;
    uint64_t x36;
    fiat_p65376_uint1 x37;
    uint64_t x38;
    fiat_p65376_uint1 x39;
    uint64_t x40;
    fiat_p65376_uint1 x41;
    uint64_t x42;
    fiat_p65376_uint1 x43;
    uint64_t x44;
    fiat_p65376_uint1 x45;
    uint64_t x46;
    uint64_t x47;
    uint64_t x48;
    uint64_t x49;
    uint64_t x50;
    uint64_t x51;
    uint64_t x52;
    uint64_t x53;
    uint64_t x54;
    uint64_t x55;
    uint64_t x56;
    uint64_t x57;
    uint64_t x58;
    fiat_p65376_uint1 x59;
    uint64_t x60;
    fiat_p65376_uint1 x61;
    uint64_t x62;
    fiat_p65376_uint1 x63;
    uint64_t x64;
    fiat_p65376_uint1 x65;
    uint64_t x66;
    fiat_p65376_uint1 x67;
    uint64_t x68;
    fiat_p65376_uint1 x69;
    uint64_t x70;
    fiat_p65376_uint1 x71;
    uint64_t x72;
    fiat_p65376_uint1 x73;
    uint64_t x74;
    fiat_p65376_uint1 x75;
    uint64_t x76;
    fiat_p65376_uint1 x77;
    uint64_t x78;
    fiat_p65376_uint1 x79;
    uint64_t x80;
    fiat_p65376_uint1 x81;
    uint64_t x82;
    fiat_p65376_uint1 x83;
    uint64_t x84;
    fiat_p65376_uint1 x85;
    uint64_t x86;
    fiat_p65376_uint1 x87;
    uint64_t x88;
    fiat_p65376_uint1 x89;
    uint64_t x90;
    uint64_t x91;
    uint64_t x92;
    uint64_t x93;
    uint64_t x94;
    uint64_t x95;
    uint64_t x96;
    uint64_t x97;
    uint64_t x98;
    uint64_t x99;
    uint64_t x100;
    uint64_t x101;
    uint64_t x102;
    fiat_p65376_uint1 x103;
    uint64_t x104;
    fiat_p65376_uint1 x105;
    uint64_t x106;
    fiat_p65376_uint1 x107;
    uint64_t x108;
    fiat_p65376_uint1 x109;
    uint64_t x110;
    fiat_p65376_uint1 x111;
    uint64_t x112;
    fiat_p65376_uint1 x113;
    uint64_t x114;
    fiat_p65376_uint1 x115;
    uint64_t x116;
    fiat_p65376_uint1 x117;
    uint64_t x118;
    fiat_p65376_uint1 x119;
    uint64_t x120;
    fiat_p65376_uint1 x121;
    uint64_t x122;
    fiat_p65376_uint1 x123;
    uint64_t x124;
    fiat_p65376_uint1 x125;
    uint64_t x126;
    fiat_p65376_uint1 x127;
    uint64_t x128;
    fiat_p65376_uint1 x129;
    uint64_t x130;
    fiat_p65376_uint1 x131;
    uint64_t x132;
    fiat_p65376_uint1 x133;
    uint64_t x134;
    uint64_t x135;
    uint64_t x136;
    uint64_t x137;
    uint64_t x138;
    uint64_t x139;
    uint64_t x140;
    uint64_t x141;
    uint64_t x142;
    uint64_t x143;
    uint64_t x144;
    uint64_t x145;
    uint64_t x146;
    fiat_p65376_uint1 x147;
    uint64_t x148;
    fiat_p65376_uint1 x149;
    uint64_t x150;
    fiat_p65376_uint1 x151;
    uint64_t x152;
    fiat_p65376_uint1 x153;
    uint64_t x154;
    fiat_p65376_uint1 x155;
    uint64_t x156;
    fiat_p65376_uint1 x157;
    uint64_t x158;
    fiat_p65376_uint1 x159;
    uint64_t x160;
    fiat_p65376_uint1 x161;
    uint64_t x162;
    fiat_p65376_uint1 x163;
    uint64_t x164;
    fiat_p65376_uint1 x165;
    uint64_t x166;
    fiat_p65376_uint1 x167;
    uint64_t x168;
    fiat_p65376_uint1 x169;
    uint64_t x170;
    fiat_p65376_uint1 x171;
    uint64_t x172;
    fiat_p65376_uint1 x173;
    uint64_t x174;
    fiat_p65376_uint1 x175;
    uint64_t x176;
    fiat_p65376_uint1 x177;
    uint64_t x178;
    uint64_t x179;
    uint64_t x180;
    uint64_t x181;
    uint64_t x182;
    uint64_t x183;
    uint64_t x184;
    uint64_t x185;
    uint64_t x186;
    uint64_t x187;
    uint64_t x188;
    uint64_t x189;
    uint64_t x190;
    fiat_p65376_uint1 x191;
    uint64_t x192;
    fiat_p65376_uint1 x193;
    uint64_t x194;
    fiat_p65376_uint1 x195;
    uint64_t x196;
    fiat_p65376_uint1 x197;
    uint64_t x198;
    fiat_p65376_uint1 x199;
    uint64_t x200;
    fiat_p65376_uint1 x201;
    uint64_t x202;
    fiat_p65376_uint1 x203;
    uint64_t x204;
    fiat_p65376_uint1 x205;
    uint64_t x206;
    fiat_p65376_uint1 x207;
    uint64_t x208;
    fiat_p65376_uint1 x209;
    uint64_t x210;
    fiat_p65376_uint1 x211;
    uint64_t x212;
    fiat_p65376_uint1 x213;
    uint64_t x214;
    fiat_p65376_uint1 x215;
    uint64_t x216;
    fiat_p65376_uint1 x217;
    uint64_t x218;
    fiat_p65376_uint1 x219;
    uint64_t x220;
    fiat_p65376_uint1 x221;
    uint64_t x222;
    uint64_t x223;
    uint64_t x224;
    uint64_t x225;
    uint64_t x226;
    uint64_t x227;
    uint64_t x228;
    uint64_t x229;
    uint64_t x230;
    uint64_t x231;
    uint64_t x232;
    uint64_t x233;
    uint64_t x234;
    fiat_p65376_uint1 x235;
    uint64_t x236;
    fiat_p65376_uint1 x237;
    uint64_t x238;
    fiat_p65376_uint1 x239;
    uint64_t x240;
    fiat_p65376_uint1 x241;
    uint64_t x242;
    fiat_p65376_uint1 x243;
    uint64_t x244;
    fiat_p65376_uint1 x245;
    uint64_t x246;
    fiat_p65376_uint1 x247;
    uint64_t x248;
    fiat_p65376_uint1 x249;
    uint64_t x250;
    fiat_p65376_uint1 x251;
    uint64_t x252;
    fiat_p65376_uint1 x253;
    uint64_t x254;
    fiat_p65376_uint1 x255;
    uint64_t x256;
    uint64_t x257;
    fiat_p65376_uint1 x258;
    uint64_t x259;
    fiat_p65376_uint1 x260;
    uint64_t x261;
    fiat_p65376_uint1 x262;
    uint64_t x263;
    fiat_p65376_uint1 x264;
    uint64_t x265;
    fiat_p65376_uint1 x266;
    uint64_t x267;
    fiat_p65376_uint1 x268;
    uint64_t x269;
    fiat_p65376_uint1 x270;
    uint64_t x271;
    uint64_t x272;
    uint64_t x273;
    uint64_t x274;
    uint64_t x275;
    uint64_t x276;
    x1 = (arg1[0]);
    fiat_p65376_mulx_u64(&x2, &x3, x1, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x4, &x5, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x6, &x7, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x8, &x9, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x10, &x11, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x12, &x13, x1, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x14, &x15, 0x0, x13, x10);
    fiat_p65376_addcarryx_u64(&x16, &x17, x15, x11, x8);
    fiat_p65376_addcarryx_u64(&x18, &x19, x17, x9, x6);
    fiat_p65376_addcarryx_u64(&x20, &x21, x19, x7, x4);
    fiat_p65376_addcarryx_u64(&x22, &x23, x21, x5, x2);
    fiat_p65376_addcarryx_u64(&x24, &x25, 0x0, x1, x12);
    fiat_p65376_addcarryx_u64(&x26, &x27, x25, 0x0, x14);
    fiat_p65376_addcarryx_u64(&x28, &x29, x27, 0x0, x16);
    fiat_p65376_addcarryx_u64(&x30, &x31, x29, 0x0, x18);
    fiat_p65376_addcarryx_u64(&x32, &x33, x31, 0x0, x20);
    fiat_p65376_addcarryx_u64(&x34, &x35, x33, 0x0, x22);
    fiat_p65376_addcarryx_u64(&x36, &x37, 0x0, x26, (arg1[1]));
    fiat_p65376_addcarryx_u64(&x38, &x39, x37, x28, 0x0);
    fiat_p65376_addcarryx_u64(&x40, &x41, x39, x30, 0x0);
    fiat_p65376_addcarryx_u64(&x42, &x43, x41, x32, 0x0);
    fiat_p65376_addcarryx_u64(&x44, &x45, x43, x34, 0x0);
    fiat_p65376_mulx_u64(&x46, &x47, x36, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x48, &x49, x36, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x50, &x51, x36, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x52, &x53, x36, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x54, &x55, x36, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x56, &x57, x36, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x58, &x59, 0x0, x57, x54);
    fiat_p65376_addcarryx_u64(&x60, &x61, x59, x55, x52);
    fiat_p65376_addcarryx_u64(&x62, &x63, x61, x53, x50);
    fiat_p65376_addcarryx_u64(&x64, &x65, x63, x51, x48);
    fiat_p65376_addcarryx_u64(&x66, &x67, x65, x49, x46);
    fiat_p65376_addcarryx_u64(&x68, &x69, 0x0, x36, x56);
    fiat_p65376_addcarryx_u64(&x70, &x71, x69, x38, x58);
    fiat_p65376_addcarryx_u64(&x72, &x73, x71, x40, x60);
    fiat_p65376_addcarryx_u64(&x74, &x75, x73, x42, x62);
    fiat_p65376_addcarryx_u64(&x76, &x77, x75, x44, x64);
    fiat_p65376_addcarryx_u64(&x78, &x79, x77, (x45 + (x35 + (x23 + x3))), x66);
    fiat_p65376_addcarryx_u64(&x80, &x81, 0x0, x70, (arg1[2]));
    fiat_p65376_addcarryx_u64(&x82, &x83, x81, x72, 0x0);
    fiat_p65376_addcarryx_u64(&x84, &x85, x83, x74, 0x0);
    fiat_p65376_addcarryx_u64(&x86, &x87, x85, x76, 0x0);
    fiat_p65376_addcarryx_u64(&x88, &x89, x87, x78, 0x0);
    fiat_p65376_mulx_u64(&x90, &x91, x80, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x92, &x93, x80, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x94, &x95, x80, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x96, &x97, x80, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x98, &x99, x80, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x100, &x101, x80, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x102, &x103, 0x0, x101, x98);
    fiat_p65376_addcarryx_u64(&x104, &x105, x103, x99, x96);
    fiat_p65376_addcarryx_u64(&x106, &x107, x105, x97, x94);
    fiat_p65376_addcarryx_u64(&x108, &x109, x107, x95, x92);
    fiat_p65376_addcarryx_u64(&x110, &x111, x109, x93, x90);
    fiat_p65376_addcarryx_u64(&x112, &x113, 0x0, x80, x100);
    fiat_p65376_addcarryx_u64(&x114, &x115, x113, x82, x102);
    fiat_p65376_addcarryx_u64(&x116, &x117, x115, x84, x104);
    fiat_p65376_addcarryx_u64(&x118, &x119, x117, x86, x106);
    fiat_p65376_addcarryx_u64(&x120, &x121, x119, x88, x108);
    fiat_p65376_addcarryx_u64(&x122, &x123, x121, (x89 + (x79 + (x67 + x47))), x110);
    fiat_p65376_addcarryx_u64(&x124, &x125, 0x0, x114, (arg1[3]));
    fiat_p65376_addcarryx_u64(&x126, &x127, x125, x116, 0x0);
    fiat_p65376_addcarryx_u64(&x128, &x129, x127, x118, 0x0);
    fiat_p65376_addcarryx_u64(&x130, &x131, x129, x120, 0x0);
    fiat_p65376_addcarryx_u64(&x132, &x133, x131, x122, 0x0);
    fiat_p65376_mulx_u64(&x134, &x135, x124, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x136, &x137, x124, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x138, &x139, x124, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x140, &x141, x124, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x142, &x143, x124, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x144, &x145, x124, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x146, &x147, 0x0, x145, x142);
    fiat_p65376_addcarryx_u64(&x148, &x149, x147, x143, x140);
    fiat_p65376_addcarryx_u64(&x150, &x151, x149, x141, x138);
    fiat_p65376_addcarryx_u64(&x152, &x153, x151, x139, x136);
    fiat_p65376_addcarryx_u64(&x154, &x155, x153, x137, x134);
    fiat_p65376_addcarryx_u64(&x156, &x157, 0x0, x124, x144);
    fiat_p65376_addcarryx_u64(&x158, &x159, x157, x126, x146);
    fiat_p65376_addcarryx_u64(&x160, &x161, x159, x128, x148);
    fiat_p65376_addcarryx_u64(&x162, &x163, x161, x130, x150);
    fiat_p65376_addcarryx_u64(&x164, &x165, x163, x132, x152);
    fiat_p65376_addcarryx_u64(&x166, &x167, x165, (x133 + (x123 + (x111 + x91))), x154);
    fiat_p65376_addcarryx_u64(&x168, &x169, 0x0, x158, (arg1[4]));
    fiat_p65376_addcarryx_u64(&x170, &x171, x169, x160, 0x0);
    fiat_p65376_addcarryx_u64(&x172, &x173, x171, x162, 0x0);
    fiat_p65376_addcarryx_u64(&x174, &x175, x173, x164, 0x0);
    fiat_p65376_addcarryx_u64(&x176, &x177, x175, x166, 0x0);
    fiat_p65376_mulx_u64(&x178, &x179, x168, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x180, &x181, x168, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x182, &x183, x168, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x184, &x185, x168, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x186, &x187, x168, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x188, &x189, x168, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x190, &x191, 0x0, x189, x186);
    fiat_p65376_addcarryx_u64(&x192, &x193, x191, x187, x184);
    fiat_p65376_addcarryx_u64(&x194, &x195, x193, x185, x182);
    fiat_p65376_addcarryx_u64(&x196, &x197, x195, x183, x180);
    fiat_p65376_addcarryx_u64(&x198, &x199, x197, x181, x178);
    fiat_p65376_addcarryx_u64(&x200, &x201, 0x0, x168, x188);
    fiat_p65376_addcarryx_u64(&x202, &x203, x201, x170, x190);
    fiat_p65376_addcarryx_u64(&x204, &x205, x203, x172, x192);
    fiat_p65376_addcarryx_u64(&x206, &x207, x205, x174, x194);
    fiat_p65376_addcarryx_u64(&x208, &x209, x207, x176, x196);
    fiat_p65376_addcarryx_u64(&x210, &x211, x209, (x177 + (x167 + (x155 + x135))), x198);
    fiat_p65376_addcarryx_u64(&x212, &x213, 0x0, x202, (arg1[5]));
    fiat_p65376_addcarryx_u64(&x214, &x215, x213, x204, 0x0);
    fiat_p65376_addcarryx_u64(&x216, &x217, x215, x206, 0x0);
    fiat_p65376_addcarryx_u64(&x218, &x219, x217, x208, 0x0);
    fiat_p65376_addcarryx_u64(&x220, &x221, x219, x210, 0x0);
    fiat_p65376_mulx_u64(&x222, &x223, x212, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x224, &x225, x212, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x226, &x227, x212, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x228, &x229, x212, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x230, &x231, x212, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x232, &x233, x212, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x234, &x235, 0x0, x233, x230);
    fiat_p65376_addcarryx_u64(&x236, &x237, x235, x231, x228);
    fiat_p65376_addcarryx_u64(&x238, &x239, x237, x229, x226);
    fiat_p65376_addcarryx_u64(&x240, &x241, x239, x227, x224);
    fiat_p65376_addcarryx_u64(&x242, &x243, x241, x225, x222);
    fiat_p65376_addcarryx_u64(&x244, &x245, 0x0, x212, x232);
    fiat_p65376_addcarryx_u64(&x246, &x247, x245, x214, x234);
    fiat_p65376_addcarryx_u64(&x248, &x249, x247, x216, x236);
    fiat_p65376_addcarryx_u64(&x250, &x251, x249, x218, x238);
    fiat_p65376_addcarryx_u64(&x252, &x253, x251, x220, x240);
    fiat_p65376_addcarryx_u64(&x254, &x255, x253, (x221 + (x211 + (x199 + x179))), x242);
    x256 = (x255 + (x243 + x223));
    fiat_p65376_subborrowx_u64(&x257, &x258, 0x0, x246, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x259, &x260, x258, x248, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x261, &x262, x260, x250, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x263, &x264, x262, x252, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x265, &x266, x264, x254, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x267, &x268, x266, x256, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x269, &x270, x268, 0x0, 0x0);
    fiat_p65376_cmovznz_u64(&x271, x270, x257, x246);
    fiat_p65376_cmovznz_u64(&x272, x270, x259, x248);
    fiat_p65376_cmovznz_u64(&x273, x270, x261, x250);
    fiat_p65376_cmovznz_u64(&x274, x270, x263, x252);
    fiat_p65376_cmovznz_u64(&x275, x270, x265, x254);
    fiat_p65376_cmovznz_u64(&x276, x270, x267, x256);
    out1[0] = x271;
    out1[1] = x272;
    out1[2] = x273;
    out1[3] = x274;
    out1[4] = x275;
    out1[5] = x276;
}

/*
 * The function fiat_p65376_to_montgomery translates a field element into the Montgomery domain.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   eval (from_montgomery out1) mod m = eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_to_montgomery(fiat_p65376_montgomery_domain_field_element out1,
                          const fiat_p65376_non_montgomery_domain_field_element arg1)
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint64_t x7;
    uint64_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    uint64_t x15;
    uint64_t x16;
    uint64_t x17;
    uint64_t x18;
    uint64_t x19;
    fiat_p65376_uint1 x20;
    uint64_t x21;
    fiat_p65376_uint1 x22;
    uint64_t x23;
    fiat_p65376_uint1 x24;
    uint64_t x25;
    fiat_p65376_uint1 x26;
    uint64_t x27;
    fiat_p65376_uint1 x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint64_t x32;
    uint64_t x33;
    uint64_t x34;
    uint64_t x35;
    uint64_t x36;
    uint64_t x37;
    uint64_t x38;
    uint64_t x39;
    uint64_t x40;
    uint64_t x41;
    fiat_p65376_uint1 x42;
    uint64_t x43;
    fiat_p65376_uint1 x44;
    uint64_t x45;
    fiat_p65376_uint1 x46;
    uint64_t x47;
    fiat_p65376_uint1 x48;
    uint64_t x49;
    fiat_p65376_uint1 x50;
    uint64_t x51;
    fiat_p65376_uint1 x52;
    uint64_t x53;
    fiat_p65376_uint1 x54;
    uint64_t x55;
    fiat_p65376_uint1 x56;
    uint64_t x57;
    fiat_p65376_uint1 x58;
    uint64_t x59;
    fiat_p65376_uint1 x60;
    uint64_t x61;
    fiat_p65376_uint1 x62;
    uint64_t x63;
    uint64_t x64;
    uint64_t x65;
    uint64_t x66;
    uint64_t x67;
    uint64_t x68;
    uint64_t x69;
    uint64_t x70;
    uint64_t x71;
    uint64_t x72;
    uint64_t x73;
    uint64_t x74;
    uint64_t x75;
    fiat_p65376_uint1 x76;
    uint64_t x77;
    fiat_p65376_uint1 x78;
    uint64_t x79;
    fiat_p65376_uint1 x80;
    uint64_t x81;
    fiat_p65376_uint1 x82;
    uint64_t x83;
    fiat_p65376_uint1 x84;
    uint64_t x85;
    fiat_p65376_uint1 x86;
    uint64_t x87;
    fiat_p65376_uint1 x88;
    uint64_t x89;
    fiat_p65376_uint1 x90;
    uint64_t x91;
    fiat_p65376_uint1 x92;
    uint64_t x93;
    fiat_p65376_uint1 x94;
    uint64_t x95;
    fiat_p65376_uint1 x96;
    uint64_t x97;
    uint64_t x98;
    uint64_t x99;
    uint64_t x100;
    uint64_t x101;
    uint64_t x102;
    uint64_t x103;
    uint64_t x104;
    uint64_t x105;
    uint64_t x106;
    uint64_t x107;
    uint64_t x108;
    uint64_t x109;
    fiat_p65376_uint1 x110;
    uint64_t x111;
    fiat_p65376_uint1 x112;
    uint64_t x113;
    fiat_p65376_uint1 x114;
    uint64_t x115;
    fiat_p65376_uint1 x116;
    uint64_t x117;
    fiat_p65376_uint1 x118;
    uint64_t x119;
    fiat_p65376_uint1 x120;
    uint64_t x121;
    fiat_p65376_uint1 x122;
    uint64_t x123;
    fiat_p65376_uint1 x124;
    uint64_t x125;
    fiat_p65376_uint1 x126;
    uint64_t x127;
    fiat_p65376_uint1 x128;
    uint64_t x129;
    fiat_p65376_uint1 x130;
    uint64_t x131;
    uint64_t x132;
    uint64_t x133;
    uint64_t x134;
    uint64_t x135;
    uint64_t x136;
    uint64_t x137;
    uint64_t x138;
    uint64_t x139;
    uint64_t x140;
    uint64_t x141;
    uint64_t x142;
    uint64_t x143;
    fiat_p65376_uint1 x144;
    uint64_t x145;
    fiat_p65376_uint1 x146;
    uint64_t x147;
    fiat_p65376_uint1 x148;
    uint64_t x149;
    fiat_p65376_uint1 x150;
    uint64_t x151;
    fiat_p65376_uint1 x152;
    uint64_t x153;
    fiat_p65376_uint1 x154;
    uint64_t x155;
    fiat_p65376_uint1 x156;
    uint64_t x157;
    fiat_p65376_uint1 x158;
    uint64_t x159;
    fiat_p65376_uint1 x160;
    uint64_t x161;
    fiat_p65376_uint1 x162;
    uint64_t x163;
    fiat_p65376_uint1 x164;
    uint64_t x165;
    uint64_t x166;
    uint64_t x167;
    uint64_t x168;
    uint64_t x169;
    uint64_t x170;
    uint64_t x171;
    uint64_t x172;
    uint64_t x173;
    uint64_t x174;
    uint64_t x175;
    uint64_t x176;
    uint64_t x177;
    fiat_p65376_uint1 x178;
    uint64_t x179;
    fiat_p65376_uint1 x180;
    uint64_t x181;
    fiat_p65376_uint1 x182;
    uint64_t x183;
    fiat_p65376_uint1 x184;
    uint64_t x185;
    fiat_p65376_uint1 x186;
    uint64_t x187;
    fiat_p65376_uint1 x188;
    uint64_t x189;
    fiat_p65376_uint1 x190;
    uint64_t x191;
    fiat_p65376_uint1 x192;
    uint64_t x193;
    fiat_p65376_uint1 x194;
    uint64_t x195;
    fiat_p65376_uint1 x196;
    uint64_t x197;
    fiat_p65376_uint1 x198;
    uint64_t x199;
    uint64_t x200;
    uint64_t x201;
    uint64_t x202;
    uint64_t x203;
    uint64_t x204;
    uint64_t x205;
    uint64_t x206;
    uint64_t x207;
    uint64_t x208;
    uint64_t x209;
    uint64_t x210;
    uint64_t x211;
    fiat_p65376_uint1 x212;
    uint64_t x213;
    fiat_p65376_uint1 x214;
    uint64_t x215;
    fiat_p65376_uint1 x216;
    uint64_t x217;
    fiat_p65376_uint1 x218;
    uint64_t x219;
    fiat_p65376_uint1 x220;
    uint64_t x221;
    fiat_p65376_uint1 x222;
    uint64_t x223;
    fiat_p65376_uint1 x224;
    uint64_t x225;
    fiat_p65376_uint1 x226;
    uint64_t x227;
    fiat_p65376_uint1 x228;
    uint64_t x229;
    fiat_p65376_uint1 x230;
    uint64_t x231;
    fiat_p65376_uint1 x232;
    uint64_t x233;
    uint64_t x234;
    uint64_t x235;
    uint64_t x236;
    uint64_t x237;
    uint64_t x238;
    uint64_t x239;
    uint64_t x240;
    uint64_t x241;
    uint64_t x242;
    uint64_t x243;
    uint64_t x244;
    uint64_t x245;
    fiat_p65376_uint1 x246;
    uint64_t x247;
    fiat_p65376_uint1 x248;
    uint64_t x249;
    fiat_p65376_uint1 x250;
    uint64_t x251;
    fiat_p65376_uint1 x252;
    uint64_t x253;
    fiat_p65376_uint1 x254;
    uint64_t x255;
    fiat_p65376_uint1 x256;
    uint64_t x257;
    fiat_p65376_uint1 x258;
    uint64_t x259;
    fiat_p65376_uint1 x260;
    uint64_t x261;
    fiat_p65376_uint1 x262;
    uint64_t x263;
    fiat_p65376_uint1 x264;
    uint64_t x265;
    fiat_p65376_uint1 x266;
    uint64_t x267;
    uint64_t x268;
    uint64_t x269;
    uint64_t x270;
    uint64_t x271;
    uint64_t x272;
    uint64_t x273;
    uint64_t x274;
    uint64_t x275;
    uint64_t x276;
    uint64_t x277;
    uint64_t x278;
    uint64_t x279;
    fiat_p65376_uint1 x280;
    uint64_t x281;
    fiat_p65376_uint1 x282;
    uint64_t x283;
    fiat_p65376_uint1 x284;
    uint64_t x285;
    fiat_p65376_uint1 x286;
    uint64_t x287;
    fiat_p65376_uint1 x288;
    uint64_t x289;
    fiat_p65376_uint1 x290;
    uint64_t x291;
    fiat_p65376_uint1 x292;
    uint64_t x293;
    fiat_p65376_uint1 x294;
    uint64_t x295;
    fiat_p65376_uint1 x296;
    uint64_t x297;
    fiat_p65376_uint1 x298;
    uint64_t x299;
    fiat_p65376_uint1 x300;
    uint64_t x301;
    uint64_t x302;
    uint64_t x303;
    uint64_t x304;
    uint64_t x305;
    uint64_t x306;
    uint64_t x307;
    uint64_t x308;
    uint64_t x309;
    uint64_t x310;
    uint64_t x311;
    uint64_t x312;
    uint64_t x313;
    fiat_p65376_uint1 x314;
    uint64_t x315;
    fiat_p65376_uint1 x316;
    uint64_t x317;
    fiat_p65376_uint1 x318;
    uint64_t x319;
    fiat_p65376_uint1 x320;
    uint64_t x321;
    fiat_p65376_uint1 x322;
    uint64_t x323;
    fiat_p65376_uint1 x324;
    uint64_t x325;
    fiat_p65376_uint1 x326;
    uint64_t x327;
    fiat_p65376_uint1 x328;
    uint64_t x329;
    fiat_p65376_uint1 x330;
    uint64_t x331;
    fiat_p65376_uint1 x332;
    uint64_t x333;
    fiat_p65376_uint1 x334;
    uint64_t x335;
    uint64_t x336;
    uint64_t x337;
    uint64_t x338;
    uint64_t x339;
    uint64_t x340;
    uint64_t x341;
    uint64_t x342;
    uint64_t x343;
    uint64_t x344;
    uint64_t x345;
    uint64_t x346;
    uint64_t x347;
    fiat_p65376_uint1 x348;
    uint64_t x349;
    fiat_p65376_uint1 x350;
    uint64_t x351;
    fiat_p65376_uint1 x352;
    uint64_t x353;
    fiat_p65376_uint1 x354;
    uint64_t x355;
    fiat_p65376_uint1 x356;
    uint64_t x357;
    fiat_p65376_uint1 x358;
    uint64_t x359;
    fiat_p65376_uint1 x360;
    uint64_t x361;
    fiat_p65376_uint1 x362;
    uint64_t x363;
    fiat_p65376_uint1 x364;
    uint64_t x365;
    fiat_p65376_uint1 x366;
    uint64_t x367;
    fiat_p65376_uint1 x368;
    uint64_t x369;
    uint64_t x370;
    uint64_t x371;
    uint64_t x372;
    uint64_t x373;
    uint64_t x374;
    uint64_t x375;
    uint64_t x376;
    uint64_t x377;
    uint64_t x378;
    uint64_t x379;
    uint64_t x380;
    uint64_t x381;
    fiat_p65376_uint1 x382;
    uint64_t x383;
    fiat_p65376_uint1 x384;
    uint64_t x385;
    fiat_p65376_uint1 x386;
    uint64_t x387;
    fiat_p65376_uint1 x388;
    uint64_t x389;
    fiat_p65376_uint1 x390;
    uint64_t x391;
    fiat_p65376_uint1 x392;
    uint64_t x393;
    fiat_p65376_uint1 x394;
    uint64_t x395;
    fiat_p65376_uint1 x396;
    uint64_t x397;
    fiat_p65376_uint1 x398;
    uint64_t x399;
    fiat_p65376_uint1 x400;
    uint64_t x401;
    fiat_p65376_uint1 x402;
    uint64_t x403;
    uint64_t x404;
    fiat_p65376_uint1 x405;
    uint64_t x406;
    fiat_p65376_uint1 x407;
    uint64_t x408;
    fiat_p65376_uint1 x409;
    uint64_t x410;
    fiat_p65376_uint1 x411;
    uint64_t x412;
    fiat_p65376_uint1 x413;
    uint64_t x414;
    fiat_p65376_uint1 x415;
    uint64_t x416;
    fiat_p65376_uint1 x417;
    uint64_t x418;
    uint64_t x419;
    uint64_t x420;
    uint64_t x421;
    uint64_t x422;
    uint64_t x423;
    x1 = (arg1[1]);
    x2 = (arg1[2]);
    x3 = (arg1[3]);
    x4 = (arg1[4]);
    x5 = (arg1[5]);
    x6 = (arg1[0]);
    fiat_p65376_mulx_u64(&x7, &x8, x6, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x9, &x10, x6, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x11, &x12, x6, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x13, &x14, x6, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x15, &x16, x6, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x17, &x18, x6, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x19, &x20, 0x0, x18, x15);
    fiat_p65376_addcarryx_u64(&x21, &x22, x20, x16, x13);
    fiat_p65376_addcarryx_u64(&x23, &x24, x22, x14, x11);
    fiat_p65376_addcarryx_u64(&x25, &x26, x24, x12, x9);
    fiat_p65376_addcarryx_u64(&x27, &x28, x26, x10, x7);
    fiat_p65376_mulx_u64(&x29, &x30, x17, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x31, &x32, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x33, &x34, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x35, &x36, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x37, &x38, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x39, &x40, x17, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x41, &x42, 0x0, x40, x37);
    fiat_p65376_addcarryx_u64(&x43, &x44, x42, x38, x35);
    fiat_p65376_addcarryx_u64(&x45, &x46, x44, x36, x33);
    fiat_p65376_addcarryx_u64(&x47, &x48, x46, x34, x31);
    fiat_p65376_addcarryx_u64(&x49, &x50, x48, x32, x29);
    fiat_p65376_addcarryx_u64(&x51, &x52, 0x0, x17, x39);
    fiat_p65376_addcarryx_u64(&x53, &x54, x52, x19, x41);
    fiat_p65376_addcarryx_u64(&x55, &x56, x54, x21, x43);
    fiat_p65376_addcarryx_u64(&x57, &x58, x56, x23, x45);
    fiat_p65376_addcarryx_u64(&x59, &x60, x58, x25, x47);
    fiat_p65376_addcarryx_u64(&x61, &x62, x60, x27, x49);
    fiat_p65376_mulx_u64(&x63, &x64, x1, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x65, &x66, x1, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x67, &x68, x1, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x69, &x70, x1, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x71, &x72, x1, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x73, &x74, x1, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x75, &x76, 0x0, x74, x71);
    fiat_p65376_addcarryx_u64(&x77, &x78, x76, x72, x69);
    fiat_p65376_addcarryx_u64(&x79, &x80, x78, x70, x67);
    fiat_p65376_addcarryx_u64(&x81, &x82, x80, x68, x65);
    fiat_p65376_addcarryx_u64(&x83, &x84, x82, x66, x63);
    fiat_p65376_addcarryx_u64(&x85, &x86, 0x0, x53, x73);
    fiat_p65376_addcarryx_u64(&x87, &x88, x86, x55, x75);
    fiat_p65376_addcarryx_u64(&x89, &x90, x88, x57, x77);
    fiat_p65376_addcarryx_u64(&x91, &x92, x90, x59, x79);
    fiat_p65376_addcarryx_u64(&x93, &x94, x92, x61, x81);
    fiat_p65376_addcarryx_u64(&x95, &x96, x94, ((x62 + (x28 + x8)) + (x50 + x30)), x83);
    fiat_p65376_mulx_u64(&x97, &x98, x85, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x99, &x100, x85, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x101, &x102, x85, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x103, &x104, x85, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x105, &x106, x85, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x107, &x108, x85, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x109, &x110, 0x0, x108, x105);
    fiat_p65376_addcarryx_u64(&x111, &x112, x110, x106, x103);
    fiat_p65376_addcarryx_u64(&x113, &x114, x112, x104, x101);
    fiat_p65376_addcarryx_u64(&x115, &x116, x114, x102, x99);
    fiat_p65376_addcarryx_u64(&x117, &x118, x116, x100, x97);
    fiat_p65376_addcarryx_u64(&x119, &x120, 0x0, x85, x107);
    fiat_p65376_addcarryx_u64(&x121, &x122, x120, x87, x109);
    fiat_p65376_addcarryx_u64(&x123, &x124, x122, x89, x111);
    fiat_p65376_addcarryx_u64(&x125, &x126, x124, x91, x113);
    fiat_p65376_addcarryx_u64(&x127, &x128, x126, x93, x115);
    fiat_p65376_addcarryx_u64(&x129, &x130, x128, x95, x117);
    fiat_p65376_mulx_u64(&x131, &x132, x2, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x133, &x134, x2, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x135, &x136, x2, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x137, &x138, x2, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x139, &x140, x2, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x141, &x142, x2, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x143, &x144, 0x0, x142, x139);
    fiat_p65376_addcarryx_u64(&x145, &x146, x144, x140, x137);
    fiat_p65376_addcarryx_u64(&x147, &x148, x146, x138, x135);
    fiat_p65376_addcarryx_u64(&x149, &x150, x148, x136, x133);
    fiat_p65376_addcarryx_u64(&x151, &x152, x150, x134, x131);
    fiat_p65376_addcarryx_u64(&x153, &x154, 0x0, x121, x141);
    fiat_p65376_addcarryx_u64(&x155, &x156, x154, x123, x143);
    fiat_p65376_addcarryx_u64(&x157, &x158, x156, x125, x145);
    fiat_p65376_addcarryx_u64(&x159, &x160, x158, x127, x147);
    fiat_p65376_addcarryx_u64(&x161, &x162, x160, x129, x149);
    fiat_p65376_addcarryx_u64(
        &x163, &x164, x162, ((x130 + (x96 + (x84 + x64))) + (x118 + x98)), x151);
    fiat_p65376_mulx_u64(&x165, &x166, x153, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x167, &x168, x153, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x169, &x170, x153, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x171, &x172, x153, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x173, &x174, x153, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x175, &x176, x153, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x177, &x178, 0x0, x176, x173);
    fiat_p65376_addcarryx_u64(&x179, &x180, x178, x174, x171);
    fiat_p65376_addcarryx_u64(&x181, &x182, x180, x172, x169);
    fiat_p65376_addcarryx_u64(&x183, &x184, x182, x170, x167);
    fiat_p65376_addcarryx_u64(&x185, &x186, x184, x168, x165);
    fiat_p65376_addcarryx_u64(&x187, &x188, 0x0, x153, x175);
    fiat_p65376_addcarryx_u64(&x189, &x190, x188, x155, x177);
    fiat_p65376_addcarryx_u64(&x191, &x192, x190, x157, x179);
    fiat_p65376_addcarryx_u64(&x193, &x194, x192, x159, x181);
    fiat_p65376_addcarryx_u64(&x195, &x196, x194, x161, x183);
    fiat_p65376_addcarryx_u64(&x197, &x198, x196, x163, x185);
    fiat_p65376_mulx_u64(&x199, &x200, x3, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x201, &x202, x3, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x203, &x204, x3, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x205, &x206, x3, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x207, &x208, x3, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x209, &x210, x3, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x211, &x212, 0x0, x210, x207);
    fiat_p65376_addcarryx_u64(&x213, &x214, x212, x208, x205);
    fiat_p65376_addcarryx_u64(&x215, &x216, x214, x206, x203);
    fiat_p65376_addcarryx_u64(&x217, &x218, x216, x204, x201);
    fiat_p65376_addcarryx_u64(&x219, &x220, x218, x202, x199);
    fiat_p65376_addcarryx_u64(&x221, &x222, 0x0, x189, x209);
    fiat_p65376_addcarryx_u64(&x223, &x224, x222, x191, x211);
    fiat_p65376_addcarryx_u64(&x225, &x226, x224, x193, x213);
    fiat_p65376_addcarryx_u64(&x227, &x228, x226, x195, x215);
    fiat_p65376_addcarryx_u64(&x229, &x230, x228, x197, x217);
    fiat_p65376_addcarryx_u64(
        &x231, &x232, x230, ((x198 + (x164 + (x152 + x132))) + (x186 + x166)), x219);
    fiat_p65376_mulx_u64(&x233, &x234, x221, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x235, &x236, x221, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x237, &x238, x221, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x239, &x240, x221, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x241, &x242, x221, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x243, &x244, x221, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x245, &x246, 0x0, x244, x241);
    fiat_p65376_addcarryx_u64(&x247, &x248, x246, x242, x239);
    fiat_p65376_addcarryx_u64(&x249, &x250, x248, x240, x237);
    fiat_p65376_addcarryx_u64(&x251, &x252, x250, x238, x235);
    fiat_p65376_addcarryx_u64(&x253, &x254, x252, x236, x233);
    fiat_p65376_addcarryx_u64(&x255, &x256, 0x0, x221, x243);
    fiat_p65376_addcarryx_u64(&x257, &x258, x256, x223, x245);
    fiat_p65376_addcarryx_u64(&x259, &x260, x258, x225, x247);
    fiat_p65376_addcarryx_u64(&x261, &x262, x260, x227, x249);
    fiat_p65376_addcarryx_u64(&x263, &x264, x262, x229, x251);
    fiat_p65376_addcarryx_u64(&x265, &x266, x264, x231, x253);
    fiat_p65376_mulx_u64(&x267, &x268, x4, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x269, &x270, x4, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x271, &x272, x4, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x273, &x274, x4, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x275, &x276, x4, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x277, &x278, x4, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x279, &x280, 0x0, x278, x275);
    fiat_p65376_addcarryx_u64(&x281, &x282, x280, x276, x273);
    fiat_p65376_addcarryx_u64(&x283, &x284, x282, x274, x271);
    fiat_p65376_addcarryx_u64(&x285, &x286, x284, x272, x269);
    fiat_p65376_addcarryx_u64(&x287, &x288, x286, x270, x267);
    fiat_p65376_addcarryx_u64(&x289, &x290, 0x0, x257, x277);
    fiat_p65376_addcarryx_u64(&x291, &x292, x290, x259, x279);
    fiat_p65376_addcarryx_u64(&x293, &x294, x292, x261, x281);
    fiat_p65376_addcarryx_u64(&x295, &x296, x294, x263, x283);
    fiat_p65376_addcarryx_u64(&x297, &x298, x296, x265, x285);
    fiat_p65376_addcarryx_u64(
        &x299, &x300, x298, ((x266 + (x232 + (x220 + x200))) + (x254 + x234)), x287);
    fiat_p65376_mulx_u64(&x301, &x302, x289, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x303, &x304, x289, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x305, &x306, x289, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x307, &x308, x289, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x309, &x310, x289, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x311, &x312, x289, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x313, &x314, 0x0, x312, x309);
    fiat_p65376_addcarryx_u64(&x315, &x316, x314, x310, x307);
    fiat_p65376_addcarryx_u64(&x317, &x318, x316, x308, x305);
    fiat_p65376_addcarryx_u64(&x319, &x320, x318, x306, x303);
    fiat_p65376_addcarryx_u64(&x321, &x322, x320, x304, x301);
    fiat_p65376_addcarryx_u64(&x323, &x324, 0x0, x289, x311);
    fiat_p65376_addcarryx_u64(&x325, &x326, x324, x291, x313);
    fiat_p65376_addcarryx_u64(&x327, &x328, x326, x293, x315);
    fiat_p65376_addcarryx_u64(&x329, &x330, x328, x295, x317);
    fiat_p65376_addcarryx_u64(&x331, &x332, x330, x297, x319);
    fiat_p65376_addcarryx_u64(&x333, &x334, x332, x299, x321);
    fiat_p65376_mulx_u64(&x335, &x336, x5, UINT64_C(0x1d3f03f03f03f03f));
    fiat_p65376_mulx_u64(&x337, &x338, x5, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x339, &x340, x5, UINT64_C(0x3f03f03f03f03f03));
    fiat_p65376_mulx_u64(&x341, &x342, x5, UINT64_C(0xf03f03f03f03f03f));
    fiat_p65376_mulx_u64(&x343, &x344, x5, UINT64_C(0x3f03f03f03f03f0));
    fiat_p65376_mulx_u64(&x345, &x346, x5, UINT64_C(0x3f03f03f03f03f13));
    fiat_p65376_addcarryx_u64(&x347, &x348, 0x0, x346, x343);
    fiat_p65376_addcarryx_u64(&x349, &x350, x348, x344, x341);
    fiat_p65376_addcarryx_u64(&x351, &x352, x350, x342, x339);
    fiat_p65376_addcarryx_u64(&x353, &x354, x352, x340, x337);
    fiat_p65376_addcarryx_u64(&x355, &x356, x354, x338, x335);
    fiat_p65376_addcarryx_u64(&x357, &x358, 0x0, x325, x345);
    fiat_p65376_addcarryx_u64(&x359, &x360, x358, x327, x347);
    fiat_p65376_addcarryx_u64(&x361, &x362, x360, x329, x349);
    fiat_p65376_addcarryx_u64(&x363, &x364, x362, x331, x351);
    fiat_p65376_addcarryx_u64(&x365, &x366, x364, x333, x353);
    fiat_p65376_addcarryx_u64(
        &x367, &x368, x366, ((x334 + (x300 + (x288 + x268))) + (x322 + x302)), x355);
    fiat_p65376_mulx_u64(&x369, &x370, x357, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_mulx_u64(&x371, &x372, x357, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x373, &x374, x357, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x375, &x376, x357, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x377, &x378, x357, UINT64_C(0xffffffffffffffff));
    fiat_p65376_mulx_u64(&x379, &x380, x357, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x381, &x382, 0x0, x380, x377);
    fiat_p65376_addcarryx_u64(&x383, &x384, x382, x378, x375);
    fiat_p65376_addcarryx_u64(&x385, &x386, x384, x376, x373);
    fiat_p65376_addcarryx_u64(&x387, &x388, x386, x374, x371);
    fiat_p65376_addcarryx_u64(&x389, &x390, x388, x372, x369);
    fiat_p65376_addcarryx_u64(&x391, &x392, 0x0, x357, x379);
    fiat_p65376_addcarryx_u64(&x393, &x394, x392, x359, x381);
    fiat_p65376_addcarryx_u64(&x395, &x396, x394, x361, x383);
    fiat_p65376_addcarryx_u64(&x397, &x398, x396, x363, x385);
    fiat_p65376_addcarryx_u64(&x399, &x400, x398, x365, x387);
    fiat_p65376_addcarryx_u64(&x401, &x402, x400, x367, x389);
    x403 = ((x402 + (x368 + (x356 + x336))) + (x390 + x370));
    fiat_p65376_subborrowx_u64(&x404, &x405, 0x0, x393, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x406, &x407, x405, x395, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x408, &x409, x407, x397, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x410, &x411, x409, x399, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x412, &x413, x411, x401, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x414, &x415, x413, x403, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x416, &x417, x415, 0x0, 0x0);
    fiat_p65376_cmovznz_u64(&x418, x417, x404, x393);
    fiat_p65376_cmovznz_u64(&x419, x417, x406, x395);
    fiat_p65376_cmovznz_u64(&x420, x417, x408, x397);
    fiat_p65376_cmovznz_u64(&x421, x417, x410, x399);
    fiat_p65376_cmovznz_u64(&x422, x417, x412, x401);
    fiat_p65376_cmovznz_u64(&x423, x417, x414, x403);
    out1[0] = x418;
    out1[1] = x419;
    out1[2] = x420;
    out1[3] = x421;
    out1[4] = x422;
    out1[5] = x423;
}

/*
 * The function fiat_p65376_nonzero outputs a single non-zero word if the input is non-zero and zero
 * otherwise.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = 0 ↔ eval (from_montgomery arg1) mod m = 0
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] Output
 * Bounds: out1: [0x0 ~> 0xffffffffffffffff]
 */
void
fiat_p65376_nonzero(uint64_t *out1, const uint64_t arg1[6])
{
    uint64_t x1;
    x1 = ((arg1[0]) | ((arg1[1]) | ((arg1[2]) | ((arg1[3]) | ((arg1[4]) | (arg1[5]))))));
    *out1 = x1;
}

/*
 * The function fiat_p65376_selectznz is a multi-limb conditional select.
 *
 * Postconditions:
 *   out1 = (if arg1 = 0 then arg2 else arg3)
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0x1]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] arg3:
 * [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void
fiat_p65376_selectznz(uint64_t out1[6],
                      fiat_p65376_uint1 arg1,
                      const uint64_t arg2[6],
                      const uint64_t arg3[6])
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    fiat_p65376_cmovznz_u64(&x1, arg1, (arg2[0]), (arg3[0]));
    fiat_p65376_cmovznz_u64(&x2, arg1, (arg2[1]), (arg3[1]));
    fiat_p65376_cmovznz_u64(&x3, arg1, (arg2[2]), (arg3[2]));
    fiat_p65376_cmovznz_u64(&x4, arg1, (arg2[3]), (arg3[3]));
    fiat_p65376_cmovznz_u64(&x5, arg1, (arg2[4]), (arg3[4]));
    fiat_p65376_cmovznz_u64(&x6, arg1, (arg2[5]), (arg3[5]));
    out1[0] = x1;
    out1[1] = x2;
    out1[2] = x3;
    out1[3] = x4;
    out1[4] = x5;
    out1[5] = x6;
}

/*
 * The function fiat_p65376_to_bytes serializes a field element NOT in the Montgomery domain to
 * bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ eval arg1 < m
 * Postconditions:
 *   out1 = map (λ x, ⌊((eval arg1 mod m) mod 2^(8 * (x + 1))) / 2^(8 * x)⌋) [0..47]
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x7fffffffffffffff]] Output
 * Bounds: out1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x7f]]
 */
void
fiat_p65376_to_bytes(uint8_t out1[48], const uint64_t arg1[6])
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint8_t x7;
    uint64_t x8;
    uint8_t x9;
    uint64_t x10;
    uint8_t x11;
    uint64_t x12;
    uint8_t x13;
    uint64_t x14;
    uint8_t x15;
    uint64_t x16;
    uint8_t x17;
    uint64_t x18;
    uint8_t x19;
    uint8_t x20;
    uint8_t x21;
    uint64_t x22;
    uint8_t x23;
    uint64_t x24;
    uint8_t x25;
    uint64_t x26;
    uint8_t x27;
    uint64_t x28;
    uint8_t x29;
    uint64_t x30;
    uint8_t x31;
    uint64_t x32;
    uint8_t x33;
    uint8_t x34;
    uint8_t x35;
    uint64_t x36;
    uint8_t x37;
    uint64_t x38;
    uint8_t x39;
    uint64_t x40;
    uint8_t x41;
    uint64_t x42;
    uint8_t x43;
    uint64_t x44;
    uint8_t x45;
    uint64_t x46;
    uint8_t x47;
    uint8_t x48;
    uint8_t x49;
    uint64_t x50;
    uint8_t x51;
    uint64_t x52;
    uint8_t x53;
    uint64_t x54;
    uint8_t x55;
    uint64_t x56;
    uint8_t x57;
    uint64_t x58;
    uint8_t x59;
    uint64_t x60;
    uint8_t x61;
    uint8_t x62;
    uint8_t x63;
    uint64_t x64;
    uint8_t x65;
    uint64_t x66;
    uint8_t x67;
    uint64_t x68;
    uint8_t x69;
    uint64_t x70;
    uint8_t x71;
    uint64_t x72;
    uint8_t x73;
    uint64_t x74;
    uint8_t x75;
    uint8_t x76;
    uint8_t x77;
    uint64_t x78;
    uint8_t x79;
    uint64_t x80;
    uint8_t x81;
    uint64_t x82;
    uint8_t x83;
    uint64_t x84;
    uint8_t x85;
    uint64_t x86;
    uint8_t x87;
    uint64_t x88;
    uint8_t x89;
    uint8_t x90;
    x1 = (arg1[5]);
    x2 = (arg1[4]);
    x3 = (arg1[3]);
    x4 = (arg1[2]);
    x5 = (arg1[1]);
    x6 = (arg1[0]);
    x7 = (uint8_t)(x6 & UINT8_C(0xff));
    x8 = (x6 >> 8);
    x9 = (uint8_t)(x8 & UINT8_C(0xff));
    x10 = (x8 >> 8);
    x11 = (uint8_t)(x10 & UINT8_C(0xff));
    x12 = (x10 >> 8);
    x13 = (uint8_t)(x12 & UINT8_C(0xff));
    x14 = (x12 >> 8);
    x15 = (uint8_t)(x14 & UINT8_C(0xff));
    x16 = (x14 >> 8);
    x17 = (uint8_t)(x16 & UINT8_C(0xff));
    x18 = (x16 >> 8);
    x19 = (uint8_t)(x18 & UINT8_C(0xff));
    x20 = (uint8_t)(x18 >> 8);
    x21 = (uint8_t)(x5 & UINT8_C(0xff));
    x22 = (x5 >> 8);
    x23 = (uint8_t)(x22 & UINT8_C(0xff));
    x24 = (x22 >> 8);
    x25 = (uint8_t)(x24 & UINT8_C(0xff));
    x26 = (x24 >> 8);
    x27 = (uint8_t)(x26 & UINT8_C(0xff));
    x28 = (x26 >> 8);
    x29 = (uint8_t)(x28 & UINT8_C(0xff));
    x30 = (x28 >> 8);
    x31 = (uint8_t)(x30 & UINT8_C(0xff));
    x32 = (x30 >> 8);
    x33 = (uint8_t)(x32 & UINT8_C(0xff));
    x34 = (uint8_t)(x32 >> 8);
    x35 = (uint8_t)(x4 & UINT8_C(0xff));
    x36 = (x4 >> 8);
    x37 = (uint8_t)(x36 & UINT8_C(0xff));
    x38 = (x36 >> 8);
    x39 = (uint8_t)(x38 & UINT8_C(0xff));
    x40 = (x38 >> 8);
    x41 = (uint8_t)(x40 & UINT8_C(0xff));
    x42 = (x40 >> 8);
    x43 = (uint8_t)(x42 & UINT8_C(0xff));
    x44 = (x42 >> 8);
    x45 = (uint8_t)(x44 & UINT8_C(0xff));
    x46 = (x44 >> 8);
    x47 = (uint8_t)(x46 & UINT8_C(0xff));
    x48 = (uint8_t)(x46 >> 8);
    x49 = (uint8_t)(x3 & UINT8_C(0xff));
    x50 = (x3 >> 8);
    x51 = (uint8_t)(x50 & UINT8_C(0xff));
    x52 = (x50 >> 8);
    x53 = (uint8_t)(x52 & UINT8_C(0xff));
    x54 = (x52 >> 8);
    x55 = (uint8_t)(x54 & UINT8_C(0xff));
    x56 = (x54 >> 8);
    x57 = (uint8_t)(x56 & UINT8_C(0xff));
    x58 = (x56 >> 8);
    x59 = (uint8_t)(x58 & UINT8_C(0xff));
    x60 = (x58 >> 8);
    x61 = (uint8_t)(x60 & UINT8_C(0xff));
    x62 = (uint8_t)(x60 >> 8);
    x63 = (uint8_t)(x2 & UINT8_C(0xff));
    x64 = (x2 >> 8);
    x65 = (uint8_t)(x64 & UINT8_C(0xff));
    x66 = (x64 >> 8);
    x67 = (uint8_t)(x66 & UINT8_C(0xff));
    x68 = (x66 >> 8);
    x69 = (uint8_t)(x68 & UINT8_C(0xff));
    x70 = (x68 >> 8);
    x71 = (uint8_t)(x70 & UINT8_C(0xff));
    x72 = (x70 >> 8);
    x73 = (uint8_t)(x72 & UINT8_C(0xff));
    x74 = (x72 >> 8);
    x75 = (uint8_t)(x74 & UINT8_C(0xff));
    x76 = (uint8_t)(x74 >> 8);
    x77 = (uint8_t)(x1 & UINT8_C(0xff));
    x78 = (x1 >> 8);
    x79 = (uint8_t)(x78 & UINT8_C(0xff));
    x80 = (x78 >> 8);
    x81 = (uint8_t)(x80 & UINT8_C(0xff));
    x82 = (x80 >> 8);
    x83 = (uint8_t)(x82 & UINT8_C(0xff));
    x84 = (x82 >> 8);
    x85 = (uint8_t)(x84 & UINT8_C(0xff));
    x86 = (x84 >> 8);
    x87 = (uint8_t)(x86 & UINT8_C(0xff));
    x88 = (x86 >> 8);
    x89 = (uint8_t)(x88 & UINT8_C(0xff));
    x90 = (uint8_t)(x88 >> 8);
    out1[0] = x7;
    out1[1] = x9;
    out1[2] = x11;
    out1[3] = x13;
    out1[4] = x15;
    out1[5] = x17;
    out1[6] = x19;
    out1[7] = x20;
    out1[8] = x21;
    out1[9] = x23;
    out1[10] = x25;
    out1[11] = x27;
    out1[12] = x29;
    out1[13] = x31;
    out1[14] = x33;
    out1[15] = x34;
    out1[16] = x35;
    out1[17] = x37;
    out1[18] = x39;
    out1[19] = x41;
    out1[20] = x43;
    out1[21] = x45;
    out1[22] = x47;
    out1[23] = x48;
    out1[24] = x49;
    out1[25] = x51;
    out1[26] = x53;
    out1[27] = x55;
    out1[28] = x57;
    out1[29] = x59;
    out1[30] = x61;
    out1[31] = x62;
    out1[32] = x63;
    out1[33] = x65;
    out1[34] = x67;
    out1[35] = x69;
    out1[36] = x71;
    out1[37] = x73;
    out1[38] = x75;
    out1[39] = x76;
    out1[40] = x77;
    out1[41] = x79;
    out1[42] = x81;
    out1[43] = x83;
    out1[44] = x85;
    out1[45] = x87;
    out1[46] = x89;
    out1[47] = x90;
}

/*
 * The function fiat_p65376_from_bytes deserializes a field element NOT in the Montgomery domain
 * from bytes in little-endian order.
 *
 * Preconditions:
 *   0 ≤ bytes_eval arg1 < m
 * Postconditions:
 *   eval out1 mod m = bytes_eval arg1 mod m
 *   0 ≤ eval out1 < m
 *
 * Input Bounds:
 *   arg1: [[0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff],
 * [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~>
 * 0xff], [0x0 ~> 0xff], [0x0 ~> 0xff], [0x0 ~> 0x7f]] Output Bounds: out1: [[0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0x7fffffffffffffff]]
 */
void
fiat_p65376_from_bytes(uint64_t out1[6], const uint8_t arg1[48])
{
    uint64_t x1;
    uint64_t x2;
    uint64_t x3;
    uint64_t x4;
    uint64_t x5;
    uint64_t x6;
    uint64_t x7;
    uint8_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    uint64_t x15;
    uint8_t x16;
    uint64_t x17;
    uint64_t x18;
    uint64_t x19;
    uint64_t x20;
    uint64_t x21;
    uint64_t x22;
    uint64_t x23;
    uint8_t x24;
    uint64_t x25;
    uint64_t x26;
    uint64_t x27;
    uint64_t x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint8_t x32;
    uint64_t x33;
    uint64_t x34;
    uint64_t x35;
    uint64_t x36;
    uint64_t x37;
    uint64_t x38;
    uint64_t x39;
    uint8_t x40;
    uint64_t x41;
    uint64_t x42;
    uint64_t x43;
    uint64_t x44;
    uint64_t x45;
    uint64_t x46;
    uint64_t x47;
    uint8_t x48;
    uint64_t x49;
    uint64_t x50;
    uint64_t x51;
    uint64_t x52;
    uint64_t x53;
    uint64_t x54;
    uint64_t x55;
    uint64_t x56;
    uint64_t x57;
    uint64_t x58;
    uint64_t x59;
    uint64_t x60;
    uint64_t x61;
    uint64_t x62;
    uint64_t x63;
    uint64_t x64;
    uint64_t x65;
    uint64_t x66;
    uint64_t x67;
    uint64_t x68;
    uint64_t x69;
    uint64_t x70;
    uint64_t x71;
    uint64_t x72;
    uint64_t x73;
    uint64_t x74;
    uint64_t x75;
    uint64_t x76;
    uint64_t x77;
    uint64_t x78;
    uint64_t x79;
    uint64_t x80;
    uint64_t x81;
    uint64_t x82;
    uint64_t x83;
    uint64_t x84;
    uint64_t x85;
    uint64_t x86;
    uint64_t x87;
    uint64_t x88;
    uint64_t x89;
    uint64_t x90;
    x1 = ((uint64_t)(arg1[47]) << 56);
    x2 = ((uint64_t)(arg1[46]) << 48);
    x3 = ((uint64_t)(arg1[45]) << 40);
    x4 = ((uint64_t)(arg1[44]) << 32);
    x5 = ((uint64_t)(arg1[43]) << 24);
    x6 = ((uint64_t)(arg1[42]) << 16);
    x7 = ((uint64_t)(arg1[41]) << 8);
    x8 = (arg1[40]);
    x9 = ((uint64_t)(arg1[39]) << 56);
    x10 = ((uint64_t)(arg1[38]) << 48);
    x11 = ((uint64_t)(arg1[37]) << 40);
    x12 = ((uint64_t)(arg1[36]) << 32);
    x13 = ((uint64_t)(arg1[35]) << 24);
    x14 = ((uint64_t)(arg1[34]) << 16);
    x15 = ((uint64_t)(arg1[33]) << 8);
    x16 = (arg1[32]);
    x17 = ((uint64_t)(arg1[31]) << 56);
    x18 = ((uint64_t)(arg1[30]) << 48);
    x19 = ((uint64_t)(arg1[29]) << 40);
    x20 = ((uint64_t)(arg1[28]) << 32);
    x21 = ((uint64_t)(arg1[27]) << 24);
    x22 = ((uint64_t)(arg1[26]) << 16);
    x23 = ((uint64_t)(arg1[25]) << 8);
    x24 = (arg1[24]);
    x25 = ((uint64_t)(arg1[23]) << 56);
    x26 = ((uint64_t)(arg1[22]) << 48);
    x27 = ((uint64_t)(arg1[21]) << 40);
    x28 = ((uint64_t)(arg1[20]) << 32);
    x29 = ((uint64_t)(arg1[19]) << 24);
    x30 = ((uint64_t)(arg1[18]) << 16);
    x31 = ((uint64_t)(arg1[17]) << 8);
    x32 = (arg1[16]);
    x33 = ((uint64_t)(arg1[15]) << 56);
    x34 = ((uint64_t)(arg1[14]) << 48);
    x35 = ((uint64_t)(arg1[13]) << 40);
    x36 = ((uint64_t)(arg1[12]) << 32);
    x37 = ((uint64_t)(arg1[11]) << 24);
    x38 = ((uint64_t)(arg1[10]) << 16);
    x39 = ((uint64_t)(arg1[9]) << 8);
    x40 = (arg1[8]);
    x41 = ((uint64_t)(arg1[7]) << 56);
    x42 = ((uint64_t)(arg1[6]) << 48);
    x43 = ((uint64_t)(arg1[5]) << 40);
    x44 = ((uint64_t)(arg1[4]) << 32);
    x45 = ((uint64_t)(arg1[3]) << 24);
    x46 = ((uint64_t)(arg1[2]) << 16);
    x47 = ((uint64_t)(arg1[1]) << 8);
    x48 = (arg1[0]);
    x49 = (x47 + (uint64_t)x48);
    x50 = (x46 + x49);
    x51 = (x45 + x50);
    x52 = (x44 + x51);
    x53 = (x43 + x52);
    x54 = (x42 + x53);
    x55 = (x41 + x54);
    x56 = (x39 + (uint64_t)x40);
    x57 = (x38 + x56);
    x58 = (x37 + x57);
    x59 = (x36 + x58);
    x60 = (x35 + x59);
    x61 = (x34 + x60);
    x62 = (x33 + x61);
    x63 = (x31 + (uint64_t)x32);
    x64 = (x30 + x63);
    x65 = (x29 + x64);
    x66 = (x28 + x65);
    x67 = (x27 + x66);
    x68 = (x26 + x67);
    x69 = (x25 + x68);
    x70 = (x23 + (uint64_t)x24);
    x71 = (x22 + x70);
    x72 = (x21 + x71);
    x73 = (x20 + x72);
    x74 = (x19 + x73);
    x75 = (x18 + x74);
    x76 = (x17 + x75);
    x77 = (x15 + (uint64_t)x16);
    x78 = (x14 + x77);
    x79 = (x13 + x78);
    x80 = (x12 + x79);
    x81 = (x11 + x80);
    x82 = (x10 + x81);
    x83 = (x9 + x82);
    x84 = (x7 + (uint64_t)x8);
    x85 = (x6 + x84);
    x86 = (x5 + x85);
    x87 = (x4 + x86);
    x88 = (x3 + x87);
    x89 = (x2 + x88);
    x90 = (x1 + x89);
    out1[0] = x55;
    out1[1] = x62;
    out1[2] = x69;
    out1[3] = x76;
    out1[4] = x83;
    out1[5] = x90;
}

/*
 * The function fiat_p65376_set_one returns the field element one in the Montgomery domain.
 *
 * Postconditions:
 *   eval (from_montgomery out1) mod m = 1 mod m
 *   0 ≤ eval out1 < m
 *
 */
void
fiat_p65376_set_one(fiat_p65376_montgomery_domain_field_element out1)
{
    out1[0] = 0x3;
    out1[1] = 0x0;
    out1[2] = 0x0;
    out1[3] = 0x0;
    out1[4] = 0x0;
    out1[5] = UINT64_C(0x3d00000000000000);
}

/*
 * The function fiat_p65376_msat returns the saturated representation of the prime modulus.
 *
 * Postconditions:
 *   twos_complement_eval out1 = m
 *   0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff]]
 */
void
fiat_p65376_msat(uint64_t out1[7])
{
    out1[0] = UINT64_C(0xffffffffffffffff);
    out1[1] = UINT64_C(0xffffffffffffffff);
    out1[2] = UINT64_C(0xffffffffffffffff);
    out1[3] = UINT64_C(0xffffffffffffffff);
    out1[4] = UINT64_C(0xffffffffffffffff);
    out1[5] = UINT64_C(0x40ffffffffffffff);
    out1[6] = 0x0;
}

/*
 * The function fiat_p65376_divstep_precomp returns the precomputed value for
 * Bernstein-Yang-inversion (in montgomery form).
 *
 * Postconditions:
 *   eval (from_montgomery out1) = ⌊(m - 1) / 2⌋^(if ⌊log2 m⌋ + 1 < 46 then ⌊(49 * (⌊log2 m⌋ + 1) +
 * 80) / 17⌋ else ⌊(49 * (⌊log2 m⌋ + 1) + 57) / 17⌋) 0 ≤ eval out1 < m
 *
 * Output Bounds:
 *   out1: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void
fiat_p65376_divstep_precomp(uint64_t out1[6])
{
    out1[0] = UINT64_C(0x21020000000);
    out1[1] = 0x0;
    out1[2] = 0x0;
    out1[3] = 0x0;
    out1[4] = 0x0;
    out1[5] = 0x0;
}

/*
 * The function fiat_p65376_divstep computes a divstep.
 *
 * Preconditions:
 *   0 ≤ eval arg4 < m
 *   0 ≤ eval arg5 < m
 * Postconditions:
 *   out1 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then 1 - arg1 else 1 + arg1)
 *   twos_complement_eval out2 = (if 0 < arg1 ∧ (twos_complement_eval arg3) is odd then
 * twos_complement_eval arg3 else twos_complement_eval arg2) twos_complement_eval out3 = (if 0 <
 * arg1 ∧ (twos_complement_eval arg3) is odd then ⌊(twos_complement_eval arg3 - twos_complement_eval
 * arg2) / 2⌋ else ⌊(twos_complement_eval arg3 + (twos_complement_eval arg3 mod 2) *
 * twos_complement_eval arg2) / 2⌋) eval (from_montgomery out4) mod m = (if 0 < arg1 ∧
 * (twos_complement_eval arg3) is odd then (2 * eval (from_montgomery arg5)) mod m else (2 * eval
 * (from_montgomery arg4)) mod m) eval (from_montgomery out5) mod m = (if 0 < arg1 ∧
 * (twos_complement_eval arg3) is odd then (eval (from_montgomery arg4) - eval (from_montgomery
 * arg4)) mod m else (eval (from_montgomery arg5) + (twos_complement_eval arg3 mod 2) * eval
 * (from_montgomery arg4)) mod m) 0 ≤ eval out5 < m 0 ≤ eval out5 < m 0 ≤ eval out2 < m 0 ≤ eval
 * out3 < m
 *
 * Input Bounds:
 *   arg1: [0x0 ~> 0xffffffffffffffff]
 *   arg2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff],
 * [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff]] arg3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] arg4: [[0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] arg5: [[0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] Output Bounds: out1: [0x0 ~>
 * 0xffffffffffffffff] out2: [[0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] out3: [[0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] out4: [[0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]] out5: [[0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~>
 * 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff], [0x0 ~> 0xffffffffffffffff]]
 */
void
fiat_p65376_divstep(uint64_t *out1,
                    uint64_t out2[7],
                    uint64_t out3[7],
                    uint64_t out4[6],
                    uint64_t out5[6],
                    uint64_t arg1,
                    const uint64_t arg2[7],
                    const uint64_t arg3[7],
                    const uint64_t arg4[6],
                    const uint64_t arg5[6])
{
    uint64_t x1;
    fiat_p65376_uint1 x2;
    fiat_p65376_uint1 x3;
    uint64_t x4;
    fiat_p65376_uint1 x5;
    uint64_t x6;
    uint64_t x7;
    uint64_t x8;
    uint64_t x9;
    uint64_t x10;
    uint64_t x11;
    uint64_t x12;
    uint64_t x13;
    uint64_t x14;
    fiat_p65376_uint1 x15;
    uint64_t x16;
    fiat_p65376_uint1 x17;
    uint64_t x18;
    fiat_p65376_uint1 x19;
    uint64_t x20;
    fiat_p65376_uint1 x21;
    uint64_t x22;
    fiat_p65376_uint1 x23;
    uint64_t x24;
    fiat_p65376_uint1 x25;
    uint64_t x26;
    fiat_p65376_uint1 x27;
    uint64_t x28;
    uint64_t x29;
    uint64_t x30;
    uint64_t x31;
    uint64_t x32;
    uint64_t x33;
    uint64_t x34;
    uint64_t x35;
    uint64_t x36;
    uint64_t x37;
    uint64_t x38;
    uint64_t x39;
    uint64_t x40;
    uint64_t x41;
    fiat_p65376_uint1 x42;
    uint64_t x43;
    fiat_p65376_uint1 x44;
    uint64_t x45;
    fiat_p65376_uint1 x46;
    uint64_t x47;
    fiat_p65376_uint1 x48;
    uint64_t x49;
    fiat_p65376_uint1 x50;
    uint64_t x51;
    fiat_p65376_uint1 x52;
    uint64_t x53;
    fiat_p65376_uint1 x54;
    uint64_t x55;
    fiat_p65376_uint1 x56;
    uint64_t x57;
    fiat_p65376_uint1 x58;
    uint64_t x59;
    fiat_p65376_uint1 x60;
    uint64_t x61;
    fiat_p65376_uint1 x62;
    uint64_t x63;
    fiat_p65376_uint1 x64;
    uint64_t x65;
    fiat_p65376_uint1 x66;
    uint64_t x67;
    uint64_t x68;
    uint64_t x69;
    uint64_t x70;
    uint64_t x71;
    uint64_t x72;
    uint64_t x73;
    fiat_p65376_uint1 x74;
    uint64_t x75;
    fiat_p65376_uint1 x76;
    uint64_t x77;
    fiat_p65376_uint1 x78;
    uint64_t x79;
    fiat_p65376_uint1 x80;
    uint64_t x81;
    fiat_p65376_uint1 x82;
    uint64_t x83;
    fiat_p65376_uint1 x84;
    uint64_t x85;
    uint64_t x86;
    fiat_p65376_uint1 x87;
    uint64_t x88;
    fiat_p65376_uint1 x89;
    uint64_t x90;
    fiat_p65376_uint1 x91;
    uint64_t x92;
    fiat_p65376_uint1 x93;
    uint64_t x94;
    fiat_p65376_uint1 x95;
    uint64_t x96;
    fiat_p65376_uint1 x97;
    uint64_t x98;
    uint64_t x99;
    uint64_t x100;
    uint64_t x101;
    uint64_t x102;
    uint64_t x103;
    fiat_p65376_uint1 x104;
    uint64_t x105;
    uint64_t x106;
    uint64_t x107;
    uint64_t x108;
    uint64_t x109;
    uint64_t x110;
    uint64_t x111;
    uint64_t x112;
    fiat_p65376_uint1 x113;
    uint64_t x114;
    fiat_p65376_uint1 x115;
    uint64_t x116;
    fiat_p65376_uint1 x117;
    uint64_t x118;
    fiat_p65376_uint1 x119;
    uint64_t x120;
    fiat_p65376_uint1 x121;
    uint64_t x122;
    fiat_p65376_uint1 x123;
    uint64_t x124;
    fiat_p65376_uint1 x125;
    uint64_t x126;
    uint64_t x127;
    uint64_t x128;
    uint64_t x129;
    uint64_t x130;
    uint64_t x131;
    uint64_t x132;
    fiat_p65376_uint1 x133;
    uint64_t x134;
    fiat_p65376_uint1 x135;
    uint64_t x136;
    fiat_p65376_uint1 x137;
    uint64_t x138;
    fiat_p65376_uint1 x139;
    uint64_t x140;
    fiat_p65376_uint1 x141;
    uint64_t x142;
    fiat_p65376_uint1 x143;
    uint64_t x144;
    fiat_p65376_uint1 x145;
    uint64_t x146;
    fiat_p65376_uint1 x147;
    uint64_t x148;
    fiat_p65376_uint1 x149;
    uint64_t x150;
    fiat_p65376_uint1 x151;
    uint64_t x152;
    fiat_p65376_uint1 x153;
    uint64_t x154;
    fiat_p65376_uint1 x155;
    uint64_t x156;
    fiat_p65376_uint1 x157;
    uint64_t x158;
    fiat_p65376_uint1 x159;
    uint64_t x160;
    uint64_t x161;
    uint64_t x162;
    uint64_t x163;
    uint64_t x164;
    uint64_t x165;
    uint64_t x166;
    uint64_t x167;
    uint64_t x168;
    uint64_t x169;
    uint64_t x170;
    uint64_t x171;
    uint64_t x172;
    uint64_t x173;
    uint64_t x174;
    uint64_t x175;
    uint64_t x176;
    uint64_t x177;
    uint64_t x178;
    fiat_p65376_addcarryx_u64(&x1, &x2, 0x0, (~arg1), 0x1);
    x3 = (fiat_p65376_uint1)((fiat_p65376_uint1)(x1 >> 63) & (fiat_p65376_uint1)((arg3[0]) & 0x1));
    fiat_p65376_addcarryx_u64(&x4, &x5, 0x0, (~arg1), 0x1);
    fiat_p65376_cmovznz_u64(&x6, x3, arg1, x4);
    fiat_p65376_cmovznz_u64(&x7, x3, (arg2[0]), (arg3[0]));
    fiat_p65376_cmovznz_u64(&x8, x3, (arg2[1]), (arg3[1]));
    fiat_p65376_cmovznz_u64(&x9, x3, (arg2[2]), (arg3[2]));
    fiat_p65376_cmovznz_u64(&x10, x3, (arg2[3]), (arg3[3]));
    fiat_p65376_cmovznz_u64(&x11, x3, (arg2[4]), (arg3[4]));
    fiat_p65376_cmovznz_u64(&x12, x3, (arg2[5]), (arg3[5]));
    fiat_p65376_cmovznz_u64(&x13, x3, (arg2[6]), (arg3[6]));
    fiat_p65376_addcarryx_u64(&x14, &x15, 0x0, 0x1, (~(arg2[0])));
    fiat_p65376_addcarryx_u64(&x16, &x17, x15, 0x0, (~(arg2[1])));
    fiat_p65376_addcarryx_u64(&x18, &x19, x17, 0x0, (~(arg2[2])));
    fiat_p65376_addcarryx_u64(&x20, &x21, x19, 0x0, (~(arg2[3])));
    fiat_p65376_addcarryx_u64(&x22, &x23, x21, 0x0, (~(arg2[4])));
    fiat_p65376_addcarryx_u64(&x24, &x25, x23, 0x0, (~(arg2[5])));
    fiat_p65376_addcarryx_u64(&x26, &x27, x25, 0x0, (~(arg2[6])));
    fiat_p65376_cmovznz_u64(&x28, x3, (arg3[0]), x14);
    fiat_p65376_cmovznz_u64(&x29, x3, (arg3[1]), x16);
    fiat_p65376_cmovznz_u64(&x30, x3, (arg3[2]), x18);
    fiat_p65376_cmovznz_u64(&x31, x3, (arg3[3]), x20);
    fiat_p65376_cmovznz_u64(&x32, x3, (arg3[4]), x22);
    fiat_p65376_cmovznz_u64(&x33, x3, (arg3[5]), x24);
    fiat_p65376_cmovznz_u64(&x34, x3, (arg3[6]), x26);
    fiat_p65376_cmovznz_u64(&x35, x3, (arg4[0]), (arg5[0]));
    fiat_p65376_cmovznz_u64(&x36, x3, (arg4[1]), (arg5[1]));
    fiat_p65376_cmovznz_u64(&x37, x3, (arg4[2]), (arg5[2]));
    fiat_p65376_cmovznz_u64(&x38, x3, (arg4[3]), (arg5[3]));
    fiat_p65376_cmovznz_u64(&x39, x3, (arg4[4]), (arg5[4]));
    fiat_p65376_cmovznz_u64(&x40, x3, (arg4[5]), (arg5[5]));
    fiat_p65376_addcarryx_u64(&x41, &x42, 0x0, x35, x35);
    fiat_p65376_addcarryx_u64(&x43, &x44, x42, x36, x36);
    fiat_p65376_addcarryx_u64(&x45, &x46, x44, x37, x37);
    fiat_p65376_addcarryx_u64(&x47, &x48, x46, x38, x38);
    fiat_p65376_addcarryx_u64(&x49, &x50, x48, x39, x39);
    fiat_p65376_addcarryx_u64(&x51, &x52, x50, x40, x40);
    fiat_p65376_subborrowx_u64(&x53, &x54, 0x0, x41, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x55, &x56, x54, x43, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x57, &x58, x56, x45, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x59, &x60, x58, x47, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x61, &x62, x60, x49, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x63, &x64, x62, x51, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x65, &x66, x64, x52, 0x0);
    x67 = (arg4[5]);
    x68 = (arg4[4]);
    x69 = (arg4[3]);
    x70 = (arg4[2]);
    x71 = (arg4[1]);
    x72 = (arg4[0]);
    fiat_p65376_subborrowx_u64(&x73, &x74, 0x0, 0x0, x72);
    fiat_p65376_subborrowx_u64(&x75, &x76, x74, 0x0, x71);
    fiat_p65376_subborrowx_u64(&x77, &x78, x76, 0x0, x70);
    fiat_p65376_subborrowx_u64(&x79, &x80, x78, 0x0, x69);
    fiat_p65376_subborrowx_u64(&x81, &x82, x80, 0x0, x68);
    fiat_p65376_subborrowx_u64(&x83, &x84, x82, 0x0, x67);
    fiat_p65376_cmovznz_u64(&x85, x84, 0x0, UINT64_C(0xffffffffffffffff));
    fiat_p65376_addcarryx_u64(&x86, &x87, 0x0, x73, x85);
    fiat_p65376_addcarryx_u64(&x88, &x89, x87, x75, x85);
    fiat_p65376_addcarryx_u64(&x90, &x91, x89, x77, x85);
    fiat_p65376_addcarryx_u64(&x92, &x93, x91, x79, x85);
    fiat_p65376_addcarryx_u64(&x94, &x95, x93, x81, x85);
    fiat_p65376_addcarryx_u64(&x96, &x97, x95, x83, (x85 & UINT64_C(0x40ffffffffffffff)));
    fiat_p65376_cmovznz_u64(&x98, x3, (arg5[0]), x86);
    fiat_p65376_cmovznz_u64(&x99, x3, (arg5[1]), x88);
    fiat_p65376_cmovznz_u64(&x100, x3, (arg5[2]), x90);
    fiat_p65376_cmovznz_u64(&x101, x3, (arg5[3]), x92);
    fiat_p65376_cmovznz_u64(&x102, x3, (arg5[4]), x94);
    fiat_p65376_cmovznz_u64(&x103, x3, (arg5[5]), x96);
    x104 = (fiat_p65376_uint1)(x28 & 0x1);
    fiat_p65376_cmovznz_u64(&x105, x104, 0x0, x7);
    fiat_p65376_cmovznz_u64(&x106, x104, 0x0, x8);
    fiat_p65376_cmovznz_u64(&x107, x104, 0x0, x9);
    fiat_p65376_cmovznz_u64(&x108, x104, 0x0, x10);
    fiat_p65376_cmovznz_u64(&x109, x104, 0x0, x11);
    fiat_p65376_cmovznz_u64(&x110, x104, 0x0, x12);
    fiat_p65376_cmovznz_u64(&x111, x104, 0x0, x13);
    fiat_p65376_addcarryx_u64(&x112, &x113, 0x0, x28, x105);
    fiat_p65376_addcarryx_u64(&x114, &x115, x113, x29, x106);
    fiat_p65376_addcarryx_u64(&x116, &x117, x115, x30, x107);
    fiat_p65376_addcarryx_u64(&x118, &x119, x117, x31, x108);
    fiat_p65376_addcarryx_u64(&x120, &x121, x119, x32, x109);
    fiat_p65376_addcarryx_u64(&x122, &x123, x121, x33, x110);
    fiat_p65376_addcarryx_u64(&x124, &x125, x123, x34, x111);
    fiat_p65376_cmovznz_u64(&x126, x104, 0x0, x35);
    fiat_p65376_cmovznz_u64(&x127, x104, 0x0, x36);
    fiat_p65376_cmovznz_u64(&x128, x104, 0x0, x37);
    fiat_p65376_cmovznz_u64(&x129, x104, 0x0, x38);
    fiat_p65376_cmovznz_u64(&x130, x104, 0x0, x39);
    fiat_p65376_cmovznz_u64(&x131, x104, 0x0, x40);
    fiat_p65376_addcarryx_u64(&x132, &x133, 0x0, x98, x126);
    fiat_p65376_addcarryx_u64(&x134, &x135, x133, x99, x127);
    fiat_p65376_addcarryx_u64(&x136, &x137, x135, x100, x128);
    fiat_p65376_addcarryx_u64(&x138, &x139, x137, x101, x129);
    fiat_p65376_addcarryx_u64(&x140, &x141, x139, x102, x130);
    fiat_p65376_addcarryx_u64(&x142, &x143, x141, x103, x131);
    fiat_p65376_subborrowx_u64(&x144, &x145, 0x0, x132, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x146, &x147, x145, x134, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x148, &x149, x147, x136, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x150, &x151, x149, x138, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x152, &x153, x151, x140, UINT64_C(0xffffffffffffffff));
    fiat_p65376_subborrowx_u64(&x154, &x155, x153, x142, UINT64_C(0x40ffffffffffffff));
    fiat_p65376_subborrowx_u64(&x156, &x157, x155, x143, 0x0);
    fiat_p65376_addcarryx_u64(&x158, &x159, 0x0, x6, 0x1);
    x160 = ((x112 >> 1) | ((x114 << 63) & UINT64_C(0xffffffffffffffff)));
    x161 = ((x114 >> 1) | ((x116 << 63) & UINT64_C(0xffffffffffffffff)));
    x162 = ((x116 >> 1) | ((x118 << 63) & UINT64_C(0xffffffffffffffff)));
    x163 = ((x118 >> 1) | ((x120 << 63) & UINT64_C(0xffffffffffffffff)));
    x164 = ((x120 >> 1) | ((x122 << 63) & UINT64_C(0xffffffffffffffff)));
    x165 = ((x122 >> 1) | ((x124 << 63) & UINT64_C(0xffffffffffffffff)));
    x166 = ((x124 & UINT64_C(0x8000000000000000)) | (x124 >> 1));
    fiat_p65376_cmovznz_u64(&x167, x66, x53, x41);
    fiat_p65376_cmovznz_u64(&x168, x66, x55, x43);
    fiat_p65376_cmovznz_u64(&x169, x66, x57, x45);
    fiat_p65376_cmovznz_u64(&x170, x66, x59, x47);
    fiat_p65376_cmovznz_u64(&x171, x66, x61, x49);
    fiat_p65376_cmovznz_u64(&x172, x66, x63, x51);
    fiat_p65376_cmovznz_u64(&x173, x157, x144, x132);
    fiat_p65376_cmovznz_u64(&x174, x157, x146, x134);
    fiat_p65376_cmovznz_u64(&x175, x157, x148, x136);
    fiat_p65376_cmovznz_u64(&x176, x157, x150, x138);
    fiat_p65376_cmovznz_u64(&x177, x157, x152, x140);
    fiat_p65376_cmovznz_u64(&x178, x157, x154, x142);
    *out1 = x158;
    out2[0] = x7;
    out2[1] = x8;
    out2[2] = x9;
    out2[3] = x10;
    out2[4] = x11;
    out2[5] = x12;
    out2[6] = x13;
    out3[0] = x160;
    out3[1] = x161;
    out3[2] = x162;
    out3[3] = x163;
    out3[4] = x164;
    out3[5] = x165;
    out3[6] = x166;
    out4[0] = x167;
    out4[1] = x168;
    out4[2] = x169;
    out4[3] = x170;
    out4[4] = x171;
    out4[5] = x172;
    out5[0] = x173;
    out5[1] = x174;
    out5[2] = x175;
    out5[3] = x176;
    out5[4] = x177;
    out5[5] = x178;
}

/* End of autogenerated content */

/********************************************************************/
/*      Expose above functions using our API                        */
/********************************************************************/

#include <fp.h>

const uint64_t p[NWORDS_FIELD] = { 0xffffffffffffffff, 0xffffffffffffffff, 0xffffffffffffffff,
                                   0xffffffffffffffff, 0xffffffffffffffff, 0x40ffffffffffffff };
const uint64_t ZERO[NWORDS_FIELD] = { 0, 0, 0, 0, 0, 0 };
const uint64_t ONE[NWORDS_FIELD] = { 0x0000000000000003, 0x0000000000000000, 0x0000000000000000,
                                     0x0000000000000000, 0x0000000000000000, 0x3D00000000000000 };

void
fp_add(fp_t *out, const fp_t *a, const fp_t *b)
{
    fiat_p65376_add(*out, *a, *b);
}

void
fp_sub(fp_t *out, const fp_t *a, const fp_t *b)
{
    fiat_p65376_sub(*out, *a, *b);
}

void
fp_sqr(fp_t *out, const fp_t *a)
{
    fiat_p65376_square(*out, *a);
}

void
fp_mul(fp_t *out, const fp_t *a, const fp_t *b)
{
    fiat_p65376_mul(*out, *a, *b);
}

void
fp_tomont(fp_t *out, const fp_t *a)
{
    fiat_p65376_to_montgomery(*out, *a);
}

void
fp_frommont(fp_t *out, const fp_t *a)
{
    fiat_p65376_from_montgomery(*out, *a);
}

void
fp_mont_setone(fp_t *out)
{
    fiat_p65376_set_one(*out);
}
